#ifndef BRACKETING_H
#define BRACKETING_H

#include <math.h>

// own includings
#include "Func.h"

#define FACTOR 1.05
#define NTRY 50

namespace Basics3D
{
	//Given a function func and an initial guessed range x1 to x2, the routine expands the range
	//geometrically until a root is bracketed by the returned values x1 and x2 (in which case zbrac
	//returns 1) or until the range becomes unacceptably large (in which case zbrac returns 0).
	int zbrac(const IFunc *g,
						double *x1,
						double *x2);
	
	/////////////////////////////////////////////////////////////////////////////////////////
	//Given a function fx dened on the interval from x1-x2 subdivide the interval into n equally
	//spaced segments, and search for zero crossings of the function. nb is input as the maximum number
	//of roots sought, and is reset to the number of bracketing pairs xb1[1..nb], xb2[1..nb]
	//that are found.
	//void zbrak(float (*fx)(float), float x1, float x2, int n, float xb1[], float xb2[], int *nb);
}
#endif // BRACKETING_H
