#ifndef COMBINATION_H
#define COMBINATION_H

#include <iostream>
#include <fstream>
#include <stdio.h>
#include <string>
#include <sstream>
#include <assert.h>
#include <string.h>

// library includings
#include "aimage.h"
#include "consolap.h"
#include "alg_bresenham.h"

// own includings
#include "Point2D.h"
#include "Points2DSet.h"
#include "ImagesSet.h"

namespace Basics3D
{
	// Makes combination of several images
	class C_Combination
	{
	private:
		const T_ImagesSet<AImageMem8> &m_img;
		AImageMem8 *m_comb;

	public:
		C_Combination(const T_ImagesSet<AImageMem8> &in_img);

		// Makes combination of two member images
		void Make();
		
		// Marks corresponding points on two parts of combined image
		// by connection them by white line
		// fileName - *.dist.key - output file of Corr containing
		//                         information about correspondences
		// N - number of correspondences to mark
		//     use -1 to mark all correspondences
		void MarkCorrespondences(const std::vector<T_Points2DSet<C_Point2D>> &in_PointsSet,
														 int in_N);

		void MarkCorrespondences(const T_Points2DSet<C_Point2D> &in_PointsSet,
														 int in_n,//number of points in group
														 int in_N);// number of corr. to draw

		// Saves image m_comb
		// outputImageName - filename to save combined image
		void Save (const char *in_outputImageName);

		~C_Combination();
	};
}
#endif // COMBINATION_H
