#ifndef RECOMP_HOMOGRAPHY_H_
#define RECOMP_HOMOGRAPHY_H_

#include <vector>

//library includings
#include "num_linalg.h"

// own includings
#include "Basics3D/Points2DParamSet.h"
#include "Basics3D/Points2DSet.h"
#include "Basics3D/MatrixOperations.h"
#include "Basics3D/HomographyMatrix.h"
//#include "Basics3D/NormalizationMatrix.h"
#include "Basics3D/Point2D.h"
#include "Basics3D/Point2DParam.h"

class C_RecompHomography
{
private:
	Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> m_Homography; // homography matrix found before
	Basics3D::C_Points2DParamSet m_PointsParamSet1;		      // input sets of points with the parameter 
	Basics3D::C_Points2DParamSet m_PointsParamSet2;         // vectors on the both pictures
	float m_t1;	    			                        // threshold for distance beetwen coordinates
	float m_t2;                                   // threshold for difference between the best 
	                                              // corresponding point and next point

public:
	C_RecompHomography(const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> *in_Homography,
		                 char* in_filename1,
		                 char* in_filename2,
										 float in_t1 = 0.5,
										 float in_t2 = 10.0);
private:
	void Apply(Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> *out,
		                           int in_width2,
		                           int in_height2);

};

#endif // RECOMP_HOMOGRAPHY_H_
