#ifndef POINT_2D_PARAM_H_
#define POINT_2D_PARAM_H_

#include <vector>

//library includings
#include "num_linalg.h"

// own includings
#include "Point2D.h"
#include "MatrixOperations.h"

namespace Basics3D
{
	class C_Point2DParam : public C_Point2D
	{
	private:
		double m_sigma;
		double m_angle;
		std::vector<float> m_param;
		static const int m_paramNumb = 128;

	public:
		C_Point2DParam(double in_x,
									 double in_y,
									 int in_numb,
									 double in_sigma,
									 double in_angle,
									 const std::vector<float> &in_param);

		float Param(int i) const;

		static int ParamNumb()
		{
			return m_paramNumb;
		}

		double Distance(const C_Point2DParam &in_point) const;

		/*static void Load(T_Points2DSet<C_Point2DParam> &out_PointsSet,
		                 char *in_filename,
						         double in_t);*/
	};
}
#endif // POINT_2D_PARAM_H_
