#ifndef SOLVE_EQ_H_
#define SOLVE_EQ_H_

#include <vector>
#include <iostream>
#include <math.h>
// library includings
#include "Bracketing.h"
#include "Newton-Raphson.h"
// own includings
#include "Func.h"

namespace Basics3D
{
	class SolveEq
	{
	private:
		static const int MAX = 1000000;

	private:
		int Find(std::vector<double> &out_sol,
						 const IFuncWithDer *in_g,
						 double *io_x1,
						 double *io_x2,
						 int *io_k,
						 const double in_acc);

	public:
		int Apply(std::vector<double> &out_sol,
						  const IFuncWithDer *in_g,
						  const double in_acc);
	};
}

#endif // SOLVE_EQ_H_
