
#include "Triangulation.h"

namespace Basics3D
{
	C_Triangulation::C_Triangulation
		                       (const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 4> &in_P,
				                    const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 4> &in_P1)
	{
		for (int i = 0; i < 4; i++)
		{
			m_p1(i) = in_P(0, i);
		  m_p2(i) = in_P(1, i);
		  m_p3(i) = in_P(2, i);
			m_p1_1(i) = in_P1(0, i);
			m_p2_1(i) = in_P1(1, i);
			m_p3_1(i) = in_P1(2, i);
		}
	}

	///////////////////////////////////////////////////////////////////////////////////////
	void C_Triangulation::CreateSystem(Vtl::NumAlg::Lin::ublas::c_matrix<double, 4, 4> &out,
				                             const C_Point2D &in_p1,
														         const C_Point2D &in_p2)
	{
		Vtl::NumAlg::Lin::ublas::c_vector<double, 4> v1, v2, v3, v4;

		v1 = in_p1.X() * m_p3 - m_p1;
    v2 = in_p1.Y() * m_p3 - m_p2;
		v3 = in_p2.X() * m_p3_1 - m_p1_1;
		v4 = in_p2.Y() * m_p3_1 - m_p2_1;

		for (int i = 0; i < 4; i++)
		{
			out(0, i) = v1(i);
			out(1, i) = v2(i);
			out(2, i) = v3(i);
			out(3, i) = v4(i);
		}

		//std::cout << std::endl << std::endl;
		//T_MatrixOperations::Print(out);
    //std::cout << std::endl << std::endl;
	}

	////////////////////////////////////////////////////////////////////////////////////////
	void C_Triangulation::Get3DPoint(Vtl::NumAlg::Lin::ublas::c_vector<double, 3> &out,
		                               const C_Point2D &in_p1,
		                               const C_Point2D &in_p2)
	{
	  Vtl::NumAlg::Lin::ublas::c_matrix<double, 4, 4> system;
		CreateSystem(system, in_p1, in_p2);
		Vtl::NumAlg::Lin::ublas::c_vector<double, 4> v;
		//std::cout << std::endl << std::endl << "system" << std::endl;
		//T_MatrixOperations::Print(system);
		SolveSystem(v, system);

		for (int i = 0; i < 3; i++)
		{
			out(i) = v(i) / v(3);
		}
	}
}