#ifndef TRIANGULATION_H_
#define TRIANGULATION_H_

//library includings
#include "num_linalg.h"

//own includings
#include "SolveSystem.h"
#include "Point2D.h"
#include "MatrixOperations.h"

namespace Basics3D
{
  class C_Triangulation
	{
	private:
		Vtl::NumAlg::Lin::ublas::c_vector<double, 4> m_p1;
    Vtl::NumAlg::Lin::ublas::c_vector<double, 4> m_p2;
		Vtl::NumAlg::Lin::ublas::c_vector<double, 4> m_p3;
		Vtl::NumAlg::Lin::ublas::c_vector<double, 4> m_p1_1;
		Vtl::NumAlg::Lin::ublas::c_vector<double, 4> m_p2_1;
		Vtl::NumAlg::Lin::ublas::c_vector<double, 4> m_p3_1;

	private:
		void CreateSystem(Vtl::NumAlg::Lin::ublas::c_matrix<double, 4, 4> &out_System,
		                  const C_Point2D &in_p1,
		                  const C_Point2D &in_p2);

	public:
		C_Triangulation(const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 4> &in_P,
				            const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 4> &in_P1);

	  void Get3DPoint(Vtl::NumAlg::Lin::ublas::c_vector<double, 3> &out,
		                const C_Point2D &in_p1,
		                const C_Point2D &in_p2);
	};
}

#endif //TRIANGULATION_H_
