// file: #include "sfm_types.h"
#ifndef _SFM_TYPES_H
#define _SFM_TYPES_H
////////////////////////////////////////////////////////////////////////////////////////
#include "num_linalg.h"

#include "Point2D.h"
#include "Points2DSet.h"
////////////////////////////////////////////////////////////////////////////////////////
namespace Basics3D
{
	/// Define struct to clear namespace from personal enum names.
	struct PointStatus
	{
		enum Flags
		{
			Ok,
			AtInfinity,
			Uncertain,
			BadReproj,
			Behind
		};
	};
	/// \brief       3D  .
	///         .
	template<typename T>
	struct Types
	{
		typedef T value_type;
		typedef boost::numeric::ublas::c_vector<value_type, 2> Vector_2;
		typedef boost::numeric::ublas::c_vector<value_type, 3> Vector_3;
		typedef boost::numeric::ublas::c_vector<value_type, 4> Vector_4;
		typedef boost::numeric::ublas::c_matrix<value_type,3,3> Matrix_3x3;
		typedef boost::numeric::ublas::c_matrix<value_type,3,4> Matrix_3x4;
		typedef boost::numeric::ublas::c_matrix<value_type,4,4> Matrix_4x4;
	};
/*
	template<int N,class Matrix> 
	class Col
	{
		//Vtl::NumAlg::Lin::ublas::c_matrix<double, N, N> U;
		typedef Matrix value_type; 
		const Matrix &m;
		const int i;
	public:
		Col(int i_,const Matrix& m_) : m(m_),i(i_) {}
		value_type operator()(int j) { return m(i,j); }
	};
*/

}//namespace Basics3D
////////////////////////////////////////////////////////////////////////////////////////
#endif //_SFM_TYPES_H
