#ifndef _IMG_UTILS_H
#define _IMG_UTILS_H
///////////////////////////////////////////////////////////////////////////////////////
namespace Vtl
{
namespace ImAlg
{
namespace Tools
{	
	template <typename ConstRandomIter, class F> 
	void copy_10_7(ConstRandomIter in1, int width, int height, int nls1, 
				   ConstRandomIter in2, int nls2, ConstRandomIter in3, int nls3, 
				   ConstRandomIter in4, int nls4, ConstRandomIter in5, int nls5, 
				   ConstRandomIter in6, int nls6, ConstRandomIter in7, int nls7, 
				   ConstRandomIter in8, int nls8, ConstRandomIter in9, int nls9,
				   ConstRandomIter in10, int nls10, ConstRandomIter out1, int nls1o,
				   ConstRandomIter out2, int nls2o, ConstRandomIter out3, int nls3o,
				   ConstRandomIter out4, int nls4o, ConstRandomIter out5, int nls5o,
				   ConstRandomIter out6, int nls6o, ConstRandomIter out7, int nls7o,
				   F functor)
	{
		for(int y=0; y<height; y++)
		{
			for(int x=0; x<width; x++)
				functor(in1[x],in2[x],in3[x],in4[x],in5[x],in6[x],in7[x],in8[x],in9[x],in10[x],
						out1[x], out2[x],out3[x],out4[x],out5[x],out6[x],out7[x]);
			in1+=nls1;
			in2+=nls2;
			in3+=nls3;
			in4+=nls4;
			in5+=nls5;
			in6+=nls6;
			in7+=nls7;
			in8+=nls8;
			in9+=nls9;
			in10+=nls10;
			out1+=nls1o;
			out2+=nls2o;
			out3+=nls3o;
			out4+=nls4o;
			out5+=nls5o;
			out6+=nls6o;
			out7+=nls7o;
		}
	};
	template <typename c_matrix, typename c_vector, class F> 
	void copy_1_2(c_matrix in1, int width, int height, int nls1, c_vector out1, 
		int nlso1, c_matrix out2, int nlso2, F functor)
	{
		for(int y=0; y<height; y++)
		{
			for(int x=0; x<width; x++)
				functor(in1[x],out1[x],out2[x]);
			in1+=nls1;
			out1+=nlso1;
			out2+=nlso2;
		}
	}
	

	
	template <typename ConstRandomIter, typename RandomIter, typename PtrToArray, class F> 
	void envTransf_3D(PtrToArray planes, int width, int height, int nls, 
					  ConstRandomIter in1,  ConstRandomIter in2,
					  ConstRandomIter in3,  ConstRandomIter in4,
					  ConstRandomIter in5,  ConstRandomIter in6,
					  RandomIter out, F functor)
	{
		int offs = 0;
		for(int y=1; y<(height-1); y++)
		{
			offs = y*nls;
		    for(int x=1; x<(width-1); x++)
			{
				//if( (x==132)&& (y==47) )
				//{
				//	std::cout << x << " " << y << std::endl;
				//}
				int i = offs+x;
				out[i]=functor(planes, i, in1[i],in2[i],in3[i],in4[i],in5[i],in6[i]);
			}
		}
	}
	
	template <typename ConstRandomIter, typename RandomIter, class F> 
	void envTransf_2Ddircheck(RandomIter image,int width,int height,int nls,ConstRandomIter h_x,ConstRandomIter h_y,ConstRandomIter grad_x,ConstRandomIter grad_y,F functor)
	{
		int offs = 0;
		for(int y=1; y<(height-1); y++)
		{
			offs = y*nls;
		    for(int x=1; x<(width-1); x++)
			{
				int i = offs+x;
				image[i]=functor(image[i], h_x[i],h_y[i],grad_x+i,grad_y+i);
			}
		}
	}


}//namespace Tools
}//namespace ImAlg
}//namespace Vtl
///////////////////////////////////////////////////////////////////////////////////////
#endif //_IMG_UTILS_H
