#ifndef DRAW_BLOB_H
#define DRAW_BLOB_H

// std includes
#include <math.h>

//own includes
#include "Semeikina/DrawEllipse.h"

template <typename T>
void DrawBlob(T* io_dstR,        // destination
              T* io_dstG,        //             image
              T* io_dstB,        //                   components
              int w,             // image
              int h,             //       size
              int nls,           // image line length
              int cx,            // center
              int cy,            //        coordinates    
              double lambda1,    // eigen
              double lambda2,    //       values
              double cosFi,      // directional cosinus
              double scale,
              T colR = T(0),     // brush
              T colG = T(0),     //      
              T colB = T(0))     //        colour)
{
  // calculate ellipse semi-axises
  double Ax = lambda1 * scale;
  double Ay = lambda2 * scale;

  // calculate slope vector
  double fi = acos(Fi);

  int pointsNumb = int(scale * 2);

  DrawEllipse(io_dstR, io_dstG, io_dstB, w, h, nls, cx, cy, Ax, Ay, fi, 
                                                 pointsNumb, colR, colG, colB);
}

#endif // DRAW_BLOB_H