// system includings
//#include <memory> 
#include <vector>
//#include <iostream>

// library includings
#include "aimage.h"
#include "consolap.h"
//#include "imalg_tools.h"
//#include "plf_functors.h"

// own includings
//#include "EdgeDetection/CannyEdgeDetector.h"
#include "SaveImageArray.h"
//#include "ImgFromGrad.h"
//#include "StatDiff.h"
#include "EdgeDetection/DiZenzoEdgeDetector.h"


namespace Tests
{
  int TestDiZenzo(int argc, char *argv[])
  {
    // Load input image
    if(argc < 2) 
    {
		  std::cout << "Argument - input image" << std::endl;
      return 0;
    }

    const char *fname = argv[1];
	  std::auto_ptr<AImage> _img(::AImageLoad(0, true, fname, indicator));
    AImageMemRgb8* img = dynamic_cast<AImageMemRgb8*>(_img.get());
	  if(!img)
    {
		  return 0;
    }

    std::vector<float> edgeStrength;
    std::vector<float> xDir;
    std::vector<float> yDir;

    DiZenzoEdgeDetector<float> diZenzo;
    diZenzo.Apply(img, (*edgeStrength)[0], (*xDir)[0], (*yDir)[0]);

    SaveImageArray((*edgeStrength)[0], img->Width(), img->Height(), fname, "_DiZenzo");
  }
} // namespace Tests