#ifndef _PLF_GISTOGRAM_H
#define _PLF_GISTOGRAM_H
/////////////////////////////////////////////////////////////////////////////
// @brief     plf_filters.h,   
namespace Vtl
{
// @brief     plf_filters.h,   
namespace Plf 
{
	/** 
	 *  @brief     Vtl::Plf::medianFilter, Vtl::Plf::medianFilter2 .
	 *   -  .
	 *
	 *   : .................
	 **********************************************************************************************/
	namespace OLSI
	{
		/** 
		 *  @brief       .
		 *
		 *   -  .
		 *
		 *      
		 *  I-, n-   I,     
		 **********************************************************************************************/
		template<typename T>
		class mediana
		{
		public:
			T I;
			int n;
			public :
				void set_m(T _I, int _n){I=_I; n = _n;};
				mediana(T I, int n) : I(I), n(n) {};
		public:	
			mediana()
			{
				I=0;
				n=0;
			};
		};
		/** 
		 *  @brief    .... .
		 *
		 *   -  .
		 *
		 *    ..............
		 **********************************************************************************************/
        template<typename T>
		class Gistogramm
		{
		protected:
			std::vector<int> gisMem;
			std::vector<int*> gishh;
			std::vector<mediana<T> > gisMedians;
			int _img_width;
			int _size_of_ramka;
		public :
			Gistogramm(){}
			void Init(int bits,  int img_width,int size_of_ramka)
			{
				int N=(1<<bits);
				gisMem.resize(img_width*N);
				gisMedians.resize(img_width);
				gishh.resize(img_width);
				for(int i=0; i<img_width; ++i)
				{
					gishh[i]=&(gisMem[i*N]);
				}
				_size_of_ramka=size_of_ramka;
				_img_width=img_width;
			}
			~Gistogramm()
			{
			}
			T getMediana_value(int x)
			{
				return getMediana(x)->I;
			}
		protected:		
			int *get_gistogram(int x)
			{
				return gishh[x];
			}
			mediana<T> *getMediana(int x)
			{
				return &(gisMedians[x]);
			}

			void del_insert_pixel_from_histogram(T I_del, T I_add, int x)
			{
				int* p;
				mediana<T> *med;
				p=get_gistogram(x);
				med=getMediana(x);
				p[I_add]++;
				p[I_del]--;
				if (med->I<I_del)
				{
					if (med->I>I_add)
					{
						if (med->n > 1)
						{
							med->n=(med->n)-1;
						}
						else 
						{
							T index= (med->I)-1;
							while (p[index]==0)index--;
							med->set_m(index, p[index]);
						}
					}
				}
				else if (med->I > I_del)
				{
					if(med->I<=I_add)
					{
						if (med->n < p[med->I])
						{
							med->n=(med->n)+1;
						}
						else
						{
							T index= (med->I)+1;
							while (p[index]==0)index++;
							med->set_m(index,1);
						}
					}
				}
				else
				{
					if (med->I<I_add)
					{
						if (med->n>p[med->I])
						{
							T index= (med->I)+1;
							while (p[index]==0)index++;
							med->set_m(index,1);
						}
					}
					else if (med->I>I_add)
					{
						if (med->n>1)
						{
							med->n=(med->n)-1;
						}
						else 
						{
							T index= (med->I)-1;
							while (p[index]==0)index--;
							med->set_m(index, p[index]);
						}
					}
				}
			}
		public:
			void add_del_lines_to_gist(const T *add, const T *del )
			{
				int ramka = 2*_size_of_ramka+1; 
				for (int i=0;i<ramka; i++)
				{
					for(int j=0;j<=i;j++)
					{
						del_insert_pixel_from_histogram(del[i],add[i],j);
					}
				}
				
				for(int i=ramka;i<_img_width;i++)
				{
					for(int j=i;j>i-ramka;j--)
					{
						del_insert_pixel_from_histogram(del[i],add[i],j);
					}
				}
				
				for(int i=_img_width;i<_img_width+2*_size_of_ramka;i++)
				{
					for(int j=_img_width-1;j>i-ramka;j--)
					{
						del_insert_pixel_from_histogram(del[i],add[i],j);
					}
				}
			}
			void initGis_of_one_line(const T *start)
			{
				int ramka = 2*_size_of_ramka+1; 
				for (int i=0;i<ramka; i++)
				{
					for(int j=0;j<=i;j++)
					{
						get_gistogram(j)[(int)start[i]]++;
					}
				}
				for(int i=ramka;i<_img_width;i++)
				{
					for(int j=i;j>i-ramka;j--)
					{
						get_gistogram(j)[(int)start[i]]++;
					}
				}
				for(int i=_img_width;i<_img_width+2*_size_of_ramka;i++)
				{
					for(int j=_img_width-1;j>i-ramka;j--)
					{
						get_gistogram(j)[(int)start[i]]++;
					}
				}
			}
			void initMediansForGistogramms(void)
			{
				int ramka=2*_size_of_ramka+1;
				unsigned count_of_pixels=(ramka*ramka)/2+1;
				for (int i=0;i<_img_width;i++)
				{
					unsigned last_pix=0;
					T ii=0;
					while (last_pix<count_of_pixels)
					{
						last_pix=last_pix+gishh[i][ii];
						ii++;
					}
					getMediana(i)->I =ii-1;
					getMediana(i)->n =(count_of_pixels-(last_pix-gishh[i][ii-1]));
				}
			}
		};
	

	/*********************************************************************************************************/

		/** 
		 *  @brief    .... .
		 *
		 *   -  .
		 *
		 *    ..............
		 **********************************************************************************************/
	template<typename T>
	class Gistogramm2: public Gistogramm<T>
		{
			std::vector<int>gisInf; 
			std::vector<int>secondParts;
	
		public: 
			void Init(int bits,  int img_width,int size_of_ramka)
			{
				int N=(1<<bits);
				gisMem.resize((img_width+size_of_ramka)*N);
				gisMedians.resize(img_width+size_of_ramka);
				gishh.resize(img_width+size_of_ramka);
				for(int i=0; i<img_width+size_of_ramka; ++i)
				{
					gishh[i]=&(gisMem[i*N]);
				}
				
				_size_of_ramka=size_of_ramka;
				_img_width=img_width;
				init_gisInf();
				init_secondParts();
			};
			~Gistogramm2()
			{
			};
		
		private:
			int *get_gisInf(int i)
			{
				return &(gisInf[2*i]);
			};

		private:
			void init_gisInf()
			{
				gisInf.resize((_img_width+_size_of_ramka)*2);
				int ramka = 2*_size_of_ramka+1;
				int n = (_img_width+_size_of_ramka)/(ramka);
				int x=0;
				int *p;
				for (int i=0;i<n;i++)
				{
					for (int it=0;it<_size_of_ramka;it++)
					{
						p=get_gisInf(x);
						p[0]=x;
						p[1]=_size_of_ramka+1;
						x++;
					}
					p=get_gisInf(x);
					p[0]=x;
					p[1]=ramka;
					++x;
					for (int it=0;it<_size_of_ramka;it++)
					{
						p=get_gisInf(x);
						p[0]=x;
						p[1]=_size_of_ramka;
						x++;
					}
				}

				int step=0;
				while (x<_img_width+_size_of_ramka)
				{
					p=get_gisInf(x);
					if (step<_size_of_ramka)
					{
						p[0]=x;
						p[1]=_size_of_ramka+1;
						x++;
						step++;
					}
					else 
					{
						p[0]=x+1;
						p[1]=_size_of_ramka;
						x++;
						step++;
					}
				}
			};

	    private:
			void init_secondParts()
			{
				secondParts.resize(_img_width);
				for(int i=0;i<_img_width;i++)
				{
					secondParts[i]=get_secont_part(i);
				}
			}

		private:
			int get_secont_part(int x) // -          
			{
				int ramka=2*_size_of_ramka+1;
				int a=(x-_size_of_ramka)/(ramka);
				int n=(_img_width+_size_of_ramka)/ramka;
				int r=_size_of_ramka;
				if (x<r)
				{
					return x+r+1;
				}
				else if (x>=n*ramka)
				{
					return x+r;
				}
				if (((x-r)==0)||(x-r)%ramka==0)
				{
					return -1;
				}
				else if ((r+a*ramka<x)&&(x<=2*r+a*ramka))
				{
					return x+r;
				}
				else if ((2*r+a*ramka<x)&&(x<r+(a+1)*ramka))
				{
					return x+r+1;
				}
				else return -1;
			}
			
			public:
				void add_del_lines_to_gist(const T *add, const T *del )
				{
					for (int i=0; i<_img_width+_size_of_ramka;i++)
					{
						int *inf = get_gisInf(i);
						int shift = inf[0];
						int step = inf[1];
						for (int it=0;it<step; it++)
						{
							del_insert_pixel_from_histogram(del[shift+it], add[shift+it], i);
						}
					}
					
				};
			public:
				void initGis_of_one_line(const T *start)
				{
					for (int i=0; i<_img_width+_size_of_ramka;i++)
					{
						int *inf = get_gisInf(i);
						int shift = inf[0];
						int step = inf[1];
						for (int it=0;it<step; it++)
						{
							get_gistogram(i)[(int)start[shift+it]]++;
						}
					}
				};
			
			public:
				void initMediansForGistogramms(void)
				{
					int ramka=2*_size_of_ramka+1;
					for (int i=0;i<_img_width+_size_of_ramka;i++)
					{
						int p_c = get_gisInf(i)[1]; 
						unsigned count_of_pixels=(p_c*ramka)/2;
						if (p_c%2!=0) count_of_pixels++;
						T last_pix=0;
						T ii=0;
						while (last_pix<count_of_pixels)
						{
							last_pix=last_pix+gishh[i][ii];
							ii++;
						}
						getMediana(i)->I=(ii-1);
						getMediana(i)->n=(count_of_pixels-(last_pix-gishh[i][ii-1]));
					}
				};
			
			public:
				T getMediana_value(int x)
				{
					int second_part = secondParts[x];
					mediana<T> *f_med = getMediana(x); 
					if (second_part==-1) return f_med ->I;
					mediana<T>  *s_med = getMediana(second_part);
					int *f_p = get_gistogram(x);
					int *s_p = get_gistogram(second_part);
					if (f_med->I == s_med->I) return f_med->I;
					
					int delt=0;
					if (f_med ->I > s_med->I)
					{
						delt=s_p[s_med->I]-s_med->n; 
						for (T it = (s_med ->I)+1; it < f_med->I; it++)
						{
							delt = delt+s_p[it];
						}
						T cur_med = f_med->I;
						int t=f_med->n-1;
						while (t<delt)
						{
							cur_med--;
							t=t+f_p[cur_med]+s_p[cur_med];
						}
						return cur_med;
					}
					else 
					{
						delt=f_p[f_med->I]-f_med->n; 
						for (T it = (f_med ->I)+1; it < s_med->I; it++)
						{
							delt = delt+f_p[it];
						}
						T cur_med = s_med->I;
						int t=s_med->n-1;
						while (t<delt)
						{
							cur_med--;
							t=t+s_p[cur_med]+f_p[cur_med];
						}
						return cur_med;
					}
				}
		};	
	}
} //namespace Plf
} //namespace Vtl
#endif //_PLF_GISTOGRAM_H
