#include <stdio.h>
#include <string>
#include <sstream>
#include <iostream>
#include <iomanip>

#include "datastring.h"
#include "loki_TypeManip.h"

//	if(3!=::sscanf(time1.c_str(),"%d%*[.,:-]%d%*[.,:-]%f",&hour,&minutes,&seconds))
///   
/// char buf[1024];
/// scanf("%[;:.^-]",buf); // ,    ,  . .
/// scanf("%[^;:.^-]",buf); // ,    ,     . .      '^'.
/// scanf("%*[^;:.^-]"); //    " ".
/// scanf("%7[;:.^-]"); //     . ,    7.
/// scanf("%*7[;:.^-]"); //    " ".

// UndelimitedStrings

template<bool reverse=false>
class UndelimitedStringEat
{
	std::string symbols;
	int n;
public:
	UndelimitedStringEat(std::string symbols_to_eat=".,:-",int n_symbols_to_eat=-1)
		:symbols(symbols_to_eat),n(n_symbols_to_eat)
	{}
	friend std::istream& operator>>(std::istream& is,UndelimitedStringEat& eat)
	{
		static const int max_count=10000;
		int count=(eat.n<0)?max_count:eat.n;
	//	std::cout << "count "<< count <<std::endl;
		for( int i=0; i<count; )
		{
			unsigned v=is.peek();
			if(is.fail() || isIn<!reverse>(eat.symbols,uint8_t(v)))
			{
				if(i==0 || ( (i+1)!=count && count!=max_count) )
					throw 1; //to SScanf returns 0 fields read
				break;
			}
			else
			{
				uint8_t c;
				is >> c;
				++i;
			}
		}
		throw 1; //to SScanf returns 0 fields read
		return is;
	}
};
template <bool v>
struct Bool2Type
{
    enum { value = v };
};

template<bool reverse=false>
class UndelimitedString
{
	std::string symbols;
	int n;
	std::string result;
public:
	UndelimitedString(std::string symbols_to_eat=".,:-",int n_symbols_to_eat=-1)
		:symbols(symbols_to_eat),n(n_symbols_to_eat)
	{}
	friend std::istream& operator>>(std::istream& is,UndelimitedString& eat)
	{
		eat.result.clear();
		static const int max_count=10000;
		int count=(eat.n<0)?max_count:eat.n;
	//	std::cout << "count "<< count <<std::endl;
		for( int i=0; i<count; )
		{
			unsigned v=is.peek();
			if(is.fail() || isIn<!reverse>(eat.symbols,uint8_t(v)))
			{
				if(i==0 || ( (i+1)!=count && count!=max_count) )
					throw 1; //to SScanf returns 0 fields read
				break;
			}
			else
			{
				uint8_t c;
				is >> c;
				eat.result+=c;
				++i;
			}
		}
		return is;
	}
	std::string str() const {return result;}
	const char * c_str() const {return result.c_str();}
};

template<bool not,typename T>
bool isIn(std::basic_string<T> s,typename std::basic_string<T>::value_type c)
{
	return isIn_(s,c,Bool2Type<not>() );
}
template<typename T>
bool isIn_(std::basic_string<T> s,typename std::basic_string<T>::value_type c,Bool2Type<false> )
{
	//std::cout << "!false!" << c << "  find(c)="<< s.find(c) <<std::endl;
	return s.find(c) < s.size();
}
template<typename T>
bool isIn_(std::basic_string<T> s,typename std::basic_string<T>::value_type c,Bool2Type<true> )
{
	//std::cout << "!true!" << c << "  find(c)="<< s.find(c) <<std::endl;
	return s.find(c) >= s.size();
}
//friend 
//template<bool reverse>



int test_Sscanf(int argc, char* argv[])
{
	char buf[20];
	int n;
	memset(buf,'_',sizeof(buf)/sizeof(buf[0])-1);buf[sizeof(buf)/sizeof(buf[0])-1]=0;
	n=sscanf(";;.^..^:--a:  ","%[;:.^-]",buf); // ,    ,  . .
	printf("1 %d<%s>\n",n,buf); memset(buf,'_',sizeof(buf)/sizeof(buf[0])-1);buf[sizeof(buf)/sizeof(buf[0])-1]=0;
	{
		UndelimitedString<false> s(";:.^-");
		n=Gen::Data::Sscanf(";;.^..^:--a:  ",s);
		printf("1 %d<%s>\n",n,s.c_str()); 
	}

	n=sscanf("  ;;.^..^:--a:  ","%[;:.^-]",buf); // ,    ,  . .
	printf("2 %d<%s>\n",n,buf);memset(buf,'_',sizeof(buf)/sizeof(buf[0])-1);buf[sizeof(buf)/sizeof(buf[0])-1]=0;
	{
		UndelimitedString<false> s(";:.^-");
		n=Gen::Data::Sscanf("  ;;.^..^:--a:  ",s);
		printf("2 %d<%s>\n",n,s.c_str()); 
	}

	n=sscanf("asd;;.^..^:--a:  ","%[^;:.^-]",buf); // ,    ,     . .      '^'.
	printf("3 %d<%s>\n",n,buf);memset(buf,'_',sizeof(buf)/sizeof(buf[0])-1);buf[sizeof(buf)/sizeof(buf[0])-1]=0;
	{
		UndelimitedString<true> s(";:.^-");
		n=Gen::Data::Sscanf("asd;;.^..^:--a:  ",s);
		printf("3 %d<%s>\n",n,s.c_str()); 
	}

	n=sscanf("asd ;;.^..^:--a:  ","%*[^;:.^-]"); //    " ".
	printf("4 %d<%s>\n",n,buf);memset(buf,'_',sizeof(buf)/sizeof(buf[0])-1);buf[sizeof(buf)/sizeof(buf[0])-1]=0;
	{
		UndelimitedStringEat<false> s(";:.^-");
		n=Gen::Data::Sscanf("asd ;;.^..^:--a:  ",s);
		printf("4 %d<%s>\n",n,buf); 
	}

	n=sscanf(";;.^..^:--a:  ","%7[;:.^-]",buf); //     . ,    7.
	printf("5 %d<%s>\n",n,buf);memset(buf,'_',sizeof(buf)/sizeof(buf[0])-1);buf[sizeof(buf)/sizeof(buf[0])-1]=0;
	{
		UndelimitedString<false> s(";:.^-",7);
		n=Gen::Data::Sscanf(";;.^..^:--a:  ",s);
		printf("5 %d<%s>\n",n,s.c_str()); 
	}

	int a,b;
	a=0;b=0;
	n=sscanf("12test12","%dtest%d",&a,&b); //     . ,    7.
	printf("6: %d %d %d\n",n,a,b);

	a=0;b=0;
	n=sscanf("12 test  12","%d test %d",&a,&b); //     . ,    7.
	printf("7: %d %d %d\n",n,a,b);

	a=0;b=0;
	n=sscanf("12te st12","%dtest%d",&a,&b); //     . ,    7.
	printf("8: %d %d %d\n",n,a,b);

	a=0;b=0;
	n=sscanf("12teasst12","%dtest%d",&a,&b); //     . ,    7.
	printf("9: %d %d %d\n",n,a,b);

	memset(buf,'_',sizeof(buf)/sizeof(buf[0])-1);buf[sizeof(buf)/sizeof(buf[0])-1]=0;
	{
		int hour=-1;
		int min=-1;
		int sec=-1;
		int n=Gen::Data::Sscanf("23:58:59",hour,UndelimitedStringEat<false>(":./-"),min,UndelimitedStringEat<false>(":./-"),sec);
		std::cout << "n=" << n << " " << hour << min << sec << std::endl;
	}
	return 0;
}