#include <string>
#include <sstream>
#include <memory> 
#include <list>
#include <iostream>
#include <fstream>
#include <iomanip>

#include <time.h>
#include <assert.h>

#include "yfilesys.h"
#include "aimage.h"
#include "color_spaces.h"
#include "convolve.h"
#include "imalg_tools.h"
#include "imalg_resampling.h"
#include "img_registration.h"

#include "plf_functors.h"
#include "plf_kernels_1d.h"

#include "tests.h"
#include "consolap.h"

#include "Hanina/img_utils.h"
#include "Hanina/ss_ridge_det.h"
using namespace Vtl::NumAlg::Lin;

namespace Tests
{
	int test_wire_detection(int argc,char *argv[])
	{
		if(argc < 2) 
      {
				std::cout << "Command string:\n test.exe input_img output_img" <<std::endl;
            return 1;
      }
		
		// ,  auto_ptr        {}
		std::auto_ptr<AImage> _img(::AImageLoad(0,true,argv[1],indicator));

		//     ,    8 ,   
		//     -         1.
		AImageMem8* img=dynamic_cast<AImageMem8*>(_img.get());
		if(!img)
			return 1;

		//   
		const int w=img->Width();
		const int h=img->Height();
		const int sz=w*h;

		Hanina::Planes3<float> planes_3((*img)[0],w,h,img->NextLineShift());
		planes_3();
		return 0;
	}
}


			
			/*SaveImage(img,data5,w,h,w,adj_3mod,sigma,argv[1],"eig_diff");

			Vtl::Plf::Fpie::CannyNMS<float> nms(0);
			Vtl::Plf::Extent ext=nms.ext();
			Vtl::ImAlg::Tools::envTransf_3e1_1(ext,data5,w,h,w,data6,w,data7,w,data0,w,nms);

			SaveImage(img,data0,w,h,w,adj_3mod,sigma,argv[1],"eig_diff_nms");

			Hanina::ZeroCrossVisualization<float> zcv(255,0.10f);
			Vtl::Plf::F11::Comb<uint8_t,Hanina::ZeroCrossVisualization<float>,Vtl::Plf::F11::Convert<uint8_t> > adj_Luv(zcv,c_to_Byte);
			SaveImage(img,data8,w,h,w,adj_Luv,sigma,argv[1],"Luv");
	
			{
				Hanina::ZeroCross<float> zc(0);
				zc.set_IterNextLineShift(w);
				Vtl::Plf::Extent ext=zc.ext();
				Vtl::ImAlg::Tools::envTransf_1_1(ext,data8,w,h,w,data0,w,zc);
				SaveImage(img,data0,w,h,w,c_to_Byte,sigma,argv[1],"Luv_zc");
			}*/
			