//   ,   .
#include <stdio.h>
#include <algorithm>
#include <string>
//     
#include "aimage.h"
/// !!!     bmp.h, ifloat.h, imagemem.h, oz.h, pbm_file.h, tiff.h 
///        .   -   aimage.h
///       Windows    virtdib.h, zoomfact.h .

//        
#include "consolap.h"
//      indicator,     ,  
//   ProgressCounter.         .   -  
//      ,   ,    ...       
//   -      ProgressCounter  0.



int main(int argc, char* argv[])
{
        if(argc!=3)
        {
                printf("Command string:\n test.exe input_img output_img\n");
                return 1;
        }
        try
        {
                //  . !       - 
                //  .      ,        .
                //       auto_ptr,  ++ ,       
                //   ,        .
                std::auto_ptr<AImage> _im(::AImageLoad(0,true,argv[1],0));

                // auto_ptr   ,        -     .
                AImage* im=_im.get();

                //        .        
                //   ,  ,   ,      -   .
                int w=im->Width();

                //  ,    ,      -   .   ,
                //         ,     .
                switch(im->GetImageStore())
                {
                case AImage::IMGS_AImageMem8:
                //if(AImage::IMGS_AImageMem8==im->GetImageStore())
                {
                        //  8-,   .
                        AImageMem8* img=dynamic_cast<AImageMem8*>(im);
                        if(img!=0)
                        { //      case AImage::IMGS_AImageMem8     ,
                          //     .   ?
                                if(AImage::IMGC_GRAYSCALE==img->ImageClass())
                                { //  ,   .    .
                                        int h=img->Height();
                                        int y=h-1;
                                        int x=w-1;
                                        int nls=img->NextLineShift();
                                        //     :
                                        (*img)[y][x]=33;
                                        //   ,        , 
										//      .
                                        //uint8_t *p=(*img)[y];

                                        //    :
                                        uint8_t *p=(*img)[0];
                                        //           
                                        for(int y=0; y<h; y++)
                                        {
                                                for(int x=w/4; x< (w-w/4); x++)
                                                        p[x]=0;
                                                p+=nls; //     ,   ,    .
                                                        // nls    ,     . 
														//  nls -     .
                                                        // (*img)[0] -    .
                                        }
                                        // ,    !
                                        //    ,     
                                        //  ,  tif  pgm.       
                                        //    bmp  ppm !
                                        ::AImageSave(img,argv[2],0);
                                }
                                else
                                {//   -  ,  Image::IMGC_PALETTE==img->ImageClass()
                                 //      .   ,     ,
                                 //       TrueColor.    ,    . 
								 //         !
                                        throw "Not grayscale image, probably palettered. This program don't work with this type!";
                                }
                        }
                }
                break;
                case AImage::IMGS_AImageMem16:
                        {
                        //      printf("Not realized yet!\n");

                        }
                        break;
                case AImage::IMGS_AImageMemRgb8:
                //if(AImage::IMGS_AImageMem8==im->GetImageStore())
                {
                        AImageMemRgb8* img=dynamic_cast<AImageMemRgb8*>(im);
                        if(img!=0)
                        {
                                //         (). TrueColor    
                                //  3  - ,   . !      !   
                                //   im.
                                AImageMem8* r=img->GetPlane8(0);
                                AImageMem8* g=img->GetPlane8(1);
                                AImageMem8* b=img->GetPlane8(2);
                                if(r!=0 && g!=0 && b!=0)
                                {
                                        //     ( ),  -    ,
                                        //   .
                                        int h=r->Height();
                                        int y=h-1;
                                        int x=w-1;
                                        int nls=r->NextLineShift();
                                        (*r)[y][x]=33;
                                        (*g)[y][x]=133;
                                        (*b)[y][x]=3;
                                        //uint8_t *p=(*g)[y];

                                        indicator->start(0,h-1,"Draw black strip in red channel");
                                        uint8_t *p=(*r)[0];
                                        for(int y=0; y<h; y++)
                                        {
                                                for(int x=w/4; x< (w-w/4); x++)
                                                        p[x]=0;
                                                p+=nls;
                                                indicator->current(y);
                                        }
                                        indicator->finish();
                                        ::AImageSave(r,argv[2],indicator); // indicator -        
										                                   //   .
                                }
                        }
                }
                break;
                default:
                        printf("Unsupported!\n");
                };

        }
        catch(AErrorStatusBase& msg )
        {
                printf("Exception: \nIn class %s\n In Derived class %s\n IN file %s line:%d\n Error message%s\n",
					msg.ClassName(),msg.DerivedClassName(),msg.File(),msg.Line(),msg.Msg());
        }
        catch(std::string msg)
        {
                printf("Exception: %s\n",msg.c_str());
        }
        catch(const char *msg)
        {
                printf("Exception: %s\n",msg);
        }
        return 0;
}
