/*! 
	@page dox_gen_MakeDifferentRealizationForIntegersAnsFloats How to ...            

@code

#include <string>
#include <memory>
#include <vector>
//#include <list>
#include <cmath>
//#include <ctime>
#include <iostream>

#include "vtl_types.h"
#include "examples.h"

namespace Examples
{
/// @brief  ,    ,
///         .
template<typename T,unsigned spec> class implKernel;
/// @brief     .
template<typename T> class implKernel<T,Vtl::Types::IntOrReal::Int>
{
protected:
	implKernel() {}
	const char* Get() const {return "implKernel: implementation for integers";}
public:
	int Divisor() const {return 255;}
	void Convolve()
	{
		std::cout << Get() << "  Divisor=" << Divisor() <<std::endl;
	}
};
/// @brief C      .
template<typename T> class implKernel<T,Vtl::Types::IntOrReal::Real>
{
protected:
	const char* Get() const {return "implKernel: implementation for floats";}
public:
	void Convolve()
	{
		std::cout << Get() <<std::endl;
			//<< "Divisor=" << Divisor() <<std::endl; //such function not implemented!
	}
};

/// @brief   implKernel,   -     T.
template<typename T> 
class Kernel
	: public implKernel<T,Vtl::Types::isIntOrReal<T>::Result>
{
public:
	Kernel()
	{
	}
	void Run()
	{
		Convolve();
	}
};


template<typename T>
class DoSomeJob
{
private:
	class ConvKernel;
	T mean_(T* data,int len,Vtl::Types::Int2Type<Vtl::Types::SUIntOrReal::SInt> v)
	{//,       
		T sum=0;
		if(len>0)
		{
			for(int i=0; i<len; i++)
				sum+=abs(*data++);
			sum=(sum+(len>>1))/len;
		}
		return sum;
	}
	T mean_(T* data,int len,Vtl::Types::Int2Type<Vtl::Types::SUIntOrReal::UInt> v)
	{//,       
		T sum=0;
		if(len>0)
		{
			for(int i=0; i<len; i++)
				sum+=*data++;
			sum=(sum+(len>>1))/len;
		}
		return sum;
	}
	T mean_(T* data,int len,Vtl::Types::Int2Type<Vtl::Types::SUIntOrReal::Real> v)
	{//,       
		T sum=0;
		if(len>0)
		{
			for(int i=0; i<len; i++)
				sum+=*data++;
			sum=sum/len;
		}
		return sum;
	}
//     -  ( ) 
//           ,  
//	  ,        
//	-     (  )
//	T mean_(T* data,int len,Vtl::Types::Int2Type<Vtl::Types::IntOrReal::Unknown> v)
//	{
//	}
//
public:
	T mean(T* data,int len)
	{//  ,  T       
	 //-   
		return mean_(data,len,Vtl::Types::Int2Type<Vtl::Types::isSUIntOrReal<T>::Result>() );
	}

};
};//namespace Examples
using namespace Examples;
void HowTo_MakeDifferentRealizationForIntegersAnsFloats()
{
	std::cout<<  "==============================================" << std::endl;
	std::cout<<  "void HowTo_MakeDifferentRealizationForIntegersAnsFloats()" << std::endl;

	float f[]={1,-2,3,4};
	DoSomeJob<float> dsj_1;
	float fr=dsj_1.mean(f,sizeof(f)/sizeof(f[0]));
	std::cout<< "float mean of {1,-2,3,4}="<< fr << std::endl;
	short s[]={1,-2,3,4};
	DoSomeJob<short> dsj_2;
	short sr=dsj_2.mean(s,sizeof(s)/sizeof(s[0]));
	std::cout<< "short mean of {1,-2,3,4}="<< sr << std::endl;
	unsigned u[]={1,2,3,4};
	DoSomeJob<unsigned > dsj_3;
	unsigned  ur=dsj_3.mean(u,sizeof(u)/sizeof(u[0]));
	std::cout<< "unsigned mean of {1,2,3,4}="<< ur << std::endl;

	Kernel<long double> k1;
	k1.Run();
	Kernel<short> k2;
	k2.Run();
	Kernel<__int64> k3;
	k3.Run();
	Kernel<signed char> k4;
	k4.Run();
	Kernel<float> k5;
	k5.Run();
	std::cout<<  "==============================================" << std::endl;
}

@endcode
*/
