#ifndef _PROGRCNT_H
#define _PROGRCNT_H
///////////////////////////////////////////////////////

void SetMessageLanguage(bool rus=false);
///////////////////////////////////////////////////////
/// class ProgressCounter
///      
///       
///  .
///       start() 
///   ,    
///   (      )
///        
///  russian().
///       current(),
///    .  current()
///  'true' -   ()
///   .
///      
/// finish()  error().    
///   finish().
/// @see consolap.h
///////////////////////////////////////////////////////
class ProgressCounter
{
public:
	ProgressCounter() {}
  virtual ~ProgressCounter() {}
  // next virtual functions MUST redeclared to draw ProgressBar
  // and user abort capability. These functions called ONLY by process.
  virtual bool russian() const=0;
  virtual void start(const char *filter_name,int count_start,int count_end)=0;
  virtual bool current(int count_current)=0; // if return true - process will aborted
  virtual void finish()=0;
  virtual void error(const char *msg)=0;
  virtual bool InProgress() const=0;
};

class AErrorStatusBase
{
public:
	AErrorStatusBase()          {}
	virtual ~AErrorStatusBase() {}
	virtual const char *ClassName()const=0; // class name where error occured
	virtual const char *DerivedClassName()const=0; // class name in base of wich error occured
	virtual const char *File() const=0; //source file where error occured
	virtual int Line() const=0; //line in source file where error ocurred
	virtual const char *Msg() const=0;  // return error message
	operator const char *() const {return Msg();}
};

class ErrorStatusBase
: public AErrorStatusBase
{
	const char *file;
	int line;
	const char *cls_this;
	const char *cls;
protected:
	bool msg_need_delete; 
  char *msg; //allocated/init by derived class
public:
  ErrorStatusBase(const char *fname,int nline,const char *_cls_this,const char *_cls,bool del_msg);
	virtual ~ErrorStatusBase();
	virtual const char *ClassName()const {return cls_this;} // class name where error occured
	virtual const char *DerivedClassName()const {return cls;} // class name in base of wich error occured
	virtual const char *File() const {return file; } //source file where error occured
	virtual int Line() const  {return line;} //line in source file where error ocurred
	virtual const char *Msg() const;  // return error message
};

///////////////////////////////////////////////////////
#endif //_PROGRCNT_H
