#include <windows.h>
//#include <iostream> 
#include <sstream> 
#include "loki_static_check.h"
#include "yfile.h"
#include "yfilesys.h"

#ifdef WIN32
	#define YFILESYS_WINDOWS
#endif

#include <sys\stat.h> //S_IWRITE, S_IREAD

#ifdef YFILESYS_WINDOWS
	#include <windows.h>
//#else
//	#include <sys\types.h> //struct stat
//	#include <time.h>
#endif
/*
#include <io.h>
#include <fcntl.h>
#include <stdarg.h>//va_start,va_end,va_list
#include <stdio.h>//SEEK_SET
#include <string.h>//::strlen(), ::strcat()
#pragma hdrstop
*/

//#################################################
//#################################################
//#################################################

YFile::YFile()
{
	HANDLE * handle_=(HANDLE *)(&handle);
	*handle_= INVALID_HANDLE_VALUE; 
	mode=UIO_UNKNOWN;
}

//virtual
YFile::~YFile()
{
	LOKI_STATIC_CHECK(sizeof(HANDLE)<=sizeof(handle),Array_handle_in_file_yfile_h_is_too_small_to_save_HANDLE_type__Increase_it);
	_close();
}

//virtual 
bool YFile::IsOk() const 
{ 
	HANDLE * handle_=(HANDLE *)(&handle);
	return (*handle_) != INVALID_HANDLE_VALUE; 
}


int YFile::_open(const char * szFileName,OpenMode access)
{
	_close();
	HANDLE * handle_=(HANDLE *)(&handle);
	mode=access;
	// GENERIC_READ = FILE_READ_ATTRIBUTES | FILE_READ_DATA | FILE_READ_EA | STANDARD_RIGHTS_READ | SYNCHRONIZE ; 
	// GENERIC_WRITE=FILE_APPEND_DATA | FILE_WRITE_ATTRIBUTES | FILE_WRITE_DATA | FILE_WRITE_EA | STANDARD_RIGHTS_WRITE | SYNCHRONIZE ;
	DWORD dwDesiredAccess=0;
	// dwShareMode=FILE_SHARE_DELETE|FILE_SHARE_READ|FILE_SHARE_WRITE;
	DWORD dwShareMode=0;
	// A pointer to a SECURITY_ATTRIBUTES structure that determines whether or not the returned handle can be 
	// inherited by child processes. If lpSecurityAttributes is NULL, the handle cannot be inherited. 
	LPSECURITY_ATTRIBUTES lpSecurityAttributes=NULL; 
	// dwCreationDisposition=CREATE_ALWAYS|CREATE_NEW|OPEN_ALWAYS|OPEN_EXISTING|TRUNCATE_EXISTING;
	DWORD dwCreationDisposition=0;
	//When CreateFile opens a file, it combines the file flags with existing file attributes, and 
	//ignores any supplied file attributes
	DWORD dwFlagsAndAttributes=FILE_ATTRIBUTE_NORMAL; //| FILE_FLAG_NO_BUFFERING; > requires 512x bytes block read
	// A handle to a template file with the GENERIC_READ access right. The template file supplies file 
	// attributes and extended attributes for the file that is being created. This parameter can be NULL.
	HANDLE hTemplateFile=NULL;

	switch(access)
	{
	case UIO_CREATE:
		dwDesiredAccess=GENERIC_READ|GENERIC_WRITE;
		dwShareMode=FILE_SHARE_DELETE|FILE_SHARE_READ|FILE_SHARE_WRITE;
		dwCreationDisposition=CREATE_NEW;
		//*handle_ = ::_open(szFileName, O_CREAT | O_BINARY | O_EXCL  | O_RDWR , S_IWRITE | S_IREAD  );
		break;
	case UIO_CREATE_OVERWRITE:
		dwDesiredAccess=GENERIC_READ|GENERIC_WRITE;
		dwShareMode=FILE_SHARE_READ|FILE_SHARE_WRITE;
		dwCreationDisposition=CREATE_ALWAYS;//|TRUNCATE_EXISTING;
		//*handle_ = ::_open(szFileName, O_CREAT | O_BINARY | O_TRUNC | O_RDWR , S_IWRITE | S_IREAD  );
			break;
	case UIO_RDONLY:
		dwDesiredAccess=GENERIC_READ;
		dwShareMode=FILE_SHARE_READ;
		dwCreationDisposition=OPEN_EXISTING;
		//*handle_ = ::_open(szFileName, O_BINARY | O_RDONLY);
		break;
	case UIO_MODIFY:
		dwDesiredAccess=GENERIC_READ|GENERIC_WRITE;
		dwShareMode=FILE_SHARE_DELETE|FILE_SHARE_READ|FILE_SHARE_WRITE;
		dwCreationDisposition=OPEN_EXISTING;
		//*handle_ = ::_open(szFileName, O_BINARY | O_RDWR	, S_IWRITE | S_IREAD );
		break;
	default:
		*handle_=INVALID_HANDLE_VALUE;
		mode=UIO_UNKNOWN;
		return -1;
	};
	*handle_ = ::CreateFile(szFileName,dwDesiredAccess,dwShareMode,lpSecurityAttributes,dwCreationDisposition,dwFlagsAndAttributes,hTemplateFile);
	if (*handle_ == INVALID_HANDLE_VALUE)
	{
		return -1;//errFileOpen; // Error open
	}
	return 0;
}

int YFile::_close()
{
	HANDLE * handle_=(HANDLE *)(&handle);
	if(*handle_!=INVALID_HANDLE_VALUE)
	{
		//::_close(*handle_);
		::CloseHandle(*handle_);
		*handle_=INVALID_HANDLE_VALUE;
		mode=UIO_UNKNOWN;
	}
	return 0;
}

int YFile::_read(int64_t pos,void *data,int32_t len)
{
	HANDLE * handle_=(HANDLE *)(&handle);
	if(*handle_!=INVALID_HANDLE_VALUE)
	{
		LARGE_INTEGER liNewFilePointer;
		LARGE_INTEGER new_pos;
		new_pos.QuadPart=pos;
		BOOL res=::SetFilePointerEx(*handle_,new_pos,&liNewFilePointer,FILE_BEGIN);
		//::_lseek(*handle_,pos,SEEK_SET);
		if(pos!=liNewFilePointer.QuadPart)
			return -1;
//		return ::_read(*handle_,data,len);
		DWORD nBytesRead;
		BOOL bResult = ::ReadFile(*handle_,data,len,&nBytesRead,NULL) ; 
		// Check for end of file. 
		return bResult ? int32_t(nBytesRead) : 0;
	}
	return -1;
}

int YFile::_write(int64_t pos,const void *data,int32_t len)
{
	HANDLE * handle_=(HANDLE *)(&handle);
	if(*handle_!=INVALID_HANDLE_VALUE)
	{
		//DWORD SetFilePointer(HANDLE hFile,LONG lDistanceToMove,PLONG lpDistanceToMoveHigh,DWORD dwMoveMethod);
		//BOOL SetFilePointerEx(HANDLE hFile,LARGE_INTEGER liDistanceToMove,PLARGE_INTEGER lpNewFilePointer,DWORD dwMoveMethod);
		LARGE_INTEGER liNewFilePointer;
		LARGE_INTEGER new_pos;
		new_pos.QuadPart=pos;
		BOOL res=::SetFilePointerEx(*handle_,new_pos,&liNewFilePointer,FILE_BEGIN);
		//::_lseek(*handle_,pos,SEEK_SET);
		if(pos!=liNewFilePointer.QuadPart)
			return -1;
		//return ::_write(*handle_,data,len);
		DWORD nBytesWritten;
		BOOL bResult = ::WriteFile(*handle_,data,len,&nBytesWritten,NULL);
		return bResult ? int32_t(nBytesWritten) : 0;
	}
	return -1;
}
//#################################################
//#################################################
//#################################################
void YFileRead::constructor(const char *filename)
{
	HANDLE * handle_=(HANDLE *)(&handle);
	*handle_ = ::CreateFile(filename,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if (*handle_ == INVALID_HANDLE_VALUE)
	{
		std::ostringstream os;
		os << "can't open file "<< filename <<" for read. Error =" << GetLastError();
		throw os.str();
	}
}

//virtual
YFileRead::~YFileRead()
{
	LOKI_STATIC_CHECK(sizeof(HANDLE)<=sizeof(handle),Array_handle_in_file_yfile_h_is_too_small_to_save_HANDLE_type__Increase_it);
	_close();
}
void YFileRead::_close()
{
	HANDLE * handle_=(HANDLE *)(&handle);
	if(*handle_!=INVALID_HANDLE_VALUE)
	{
		//::_close(*handle_);
		::CloseHandle(*handle_);
		*handle_=INVALID_HANDLE_VALUE;
	}
}
void YFileRead::SetPosition(int64_t offset)
{
	HANDLE * handle_=(HANDLE *)(&handle);
	LARGE_INTEGER liNewFilePointer;
	LARGE_INTEGER new_pos;
	new_pos.QuadPart=offset;
	BOOL res=::SetFilePointerEx(*handle_,new_pos,&liNewFilePointer,FILE_BEGIN);
	//::_lseek(*handle_,offset,SEEK_SET);
	if(offset!=liNewFilePointer.QuadPart)
		throw std::string("YFileRead::SetPosition(int64_t offset) fail");
}
int YFileRead::read(void* data,int len)
{
	HANDLE * handle_=(HANDLE *)(&handle);
//	return ::_read(handle,data,len);
	DWORD nBytesRead;
	BOOL bResult = ::ReadFile(*handle_,data,len,&nBytesRead,NULL) ; 
	// Check for end of file. 
	return bResult ? int32_t(nBytesRead) : 0;
}
int YFileRead::read(int64_t offset,void* data,int len)
{
	SetPosition(offset);
	return read(data,len);
}
int64_t YFileRead::GetFileSize()
const
{
	HANDLE * handle_=(HANDLE *)(&handle);
	BY_HANDLE_FILE_INFORMATION fi;
	memset(&fi,0,sizeof(fi));
	if(GetFileInformationByHandle(*handle_,&fi))
	{
		uint64_t s=fi.nFileSizeHigh;
		s=(s<<32)|fi.nFileSizeLow;
		//return (fi.nFileSizeHigh)?0XFFFFFFFF:fi.nFileSizeLow; 
		return s;
	}
	return 0;
}

YDataTime YFileRead::GetTime()
const
{
	HANDLE * handle_=(HANDLE *)(&handle);
	BY_HANDLE_FILE_INFORMATION fi;
	memset(&fi,0,sizeof(fi));
	if(GetFileInformationByHandle(*handle_,&fi))
	{
		SYSTEMTIME st;
		FileTimeToSystemTime(&fi.ftLastWriteTime,&st);
		//SystemTimeToTzSpecificLocalTime(NULL, &st, &stLocal);
		return  YDataTime(st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond+double(st.wMilliseconds)/1000);
	}
	return YDataTime();
}

//#################################################
//#################################################
//#################################################
void YFileWrite::constructor(const char *filename)
{
	HANDLE * handle_=(HANDLE *)(&handle);
	// |TRUNCATE_EXISTING
	*handle_ = ::CreateFile(filename,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
//	*handle_ = ::_open(filename,O_RDWR|O_BINARY|O_TRUNC|O_CREAT,S_IREAD|S_IWRITE);
	if (*handle_ == INVALID_HANDLE_VALUE)
	{
		DWORD err_code=GetLastError();
		std::ostringstream os;
		os << "Can't create file, YFileWrite::constructor(\"" << filename << "\") fail with GetLastError =" << err_code << std::endl;
		//throw std::string("can't create file");
		throw os.str();
	}
}
//virtual
YFileWrite::~YFileWrite()
{
	LOKI_STATIC_CHECK(sizeof(HANDLE)<=sizeof(handle),Array_handle_in_file_yfile_h_is_too_small_to_save_HANDLE_type__Increase_it);
	_close();
}

void YFileWrite::_close()
{
	HANDLE * handle_=(HANDLE *)(&handle);
	if (*handle_ == INVALID_HANDLE_VALUE)
	{
		//::_close(*handle_);
		::CloseHandle(*handle_);
		*handle_ = INVALID_HANDLE_VALUE;
	}
}

void YFileWrite::SetPosition(int64_t offset)
{
//	::_lseek(handle,offset,SEEK_SET);
	HANDLE * handle_=(HANDLE *)(&handle);
	LARGE_INTEGER liNewFilePointer;
	LARGE_INTEGER new_pos;
	new_pos.QuadPart=offset;
	BOOL res=::SetFilePointerEx(*handle_,new_pos,&liNewFilePointer,FILE_BEGIN);
	//::_lseek(*handle_,offset,SEEK_SET);
	if(offset!=liNewFilePointer.QuadPart)
		throw std::string("YFileWrite::SetPosition(int64_t offset) fail");
}
int64_t YFileWrite::GetPosition()
{
//	return ::_tell(handle);
	HANDLE * handle_=(HANDLE *)(&handle);
	LARGE_INTEGER liNewFilePointer;
	LARGE_INTEGER new_pos;
	new_pos.QuadPart=0;
	BOOL res=::SetFilePointerEx(*handle_,new_pos,&liNewFilePointer,FILE_CURRENT);
	return liNewFilePointer.QuadPart;
}
int YFileWrite::write(const void* data,int len)
{
//	return ::_write(handle,data,len);
	HANDLE * handle_=(HANDLE *)(&handle);
	DWORD nBytesWritten;
	BOOL bResult = ::WriteFile(*handle_,data,len,&nBytesWritten,NULL);
	return bResult ? int32_t(nBytesWritten) : 0;
}
int YFileWrite::write(int64_t offset,const void* data,int len)
{
	SetPosition(offset);
	return write(data,len);
	//::_lseek(handle,offset,SEEK_SET);
	//return ::_write(handle,data,len);
}
///////////////////////////////////////////////////////////
// class DebugToFile provides overloaded class DebugBase
// function printf() for debug print to file
///////////////////////////////////////////////////////////
DebugToFile::DebugToFile()
:DebugBase()
{
	fp_debug=0;
}
DebugToFile::~DebugToFile()
{
	DebugToFile::Close();
}
void DebugToFile::Init(const char* fname)
{
	DebugToFile::Close();
	if(fname)
	{
		debug_fname=fname;
	}
	if(debug_fname.length()>0)
	{
		errno_t err=::fopen_s((FILE **)(&fp_debug),debug_fname.c_str(),"wt");
		if(err!=0)
		{
			std::ostringstream os;
			os<< "Error in DebugToFile::Init() when opening file for writing : " << debug_fname;
			throw os.str();
		}
	}
}
//virtual
void DebugToFile::Close()
{
	if(debug_fname.length()>0)
	{
		debug_fname="";
	}
	if(fp_debug)
	{
		::fclose((FILE*)fp_debug);
		fp_debug=0;
	}
}
//virtual
int DebugToFile::printf(const char *format,...)
const
{
	if(fp_debug)
	{
		va_list argptr;
		va_start(argptr, format);
		//char buf[1024];
		//int count=::vsprintf(buf,format,argptr);
		int count=::vfprintf((FILE*)fp_debug,format,argptr);
		va_end(argptr);
		return count;
	}
	return 0;
}

