#ifndef _XML_INTERFACE_IMP_H
#define _XML_INTERFACE_IMP_H
//////////////////////////////////////////////////////////////////////////////////
//file #include "xml_interface_imp.h"
//
//////////////////////////////////////////////////////////////////////////////////
#define YXML_USE_DLL


typedef void* YXML_DRV_DocHandle;
typedef void* YXML_DRV_NodeHandle;

#define YXML_DRV_NODETYPE_ELEMENT 1
#define YXML_DRV_NODETYPE_TEXT 2
#define YXML_DRV_NODETYPE_COMMENT 3
#define YXML_DRV_NODETYPE_ATTRIBUTE 4
#define YXML_DRV_NODETYPE_UNSUPPORTED unsigned(-1)


#if defined(YXML_DRIVER) | defined(YXML_DRIVER_USING) 

	#define YXMLDRVFUN __cdecl
	#if defined(YXML_DRIVER)
		#ifdef YXML_USE_DLL
			#define YXMLEXPORT __declspec(dllexport)
		#else
			#define YXMLEXPORT 
		#endif
	#elif defined(YXML_DRIVER_USING)
		#ifdef YXML_USE_DLL
			#define YXMLEXPORT __declspec(dllimport)
		#else
			#define YXMLEXPORT 
		#endif
	#endif


	typedef char* YXML_DRV_DomCString;


	#define YXML_DOC_DO_CREATE 1
	#define YXML_DOC_DO_LOAD   2
	#define YXML_DOC_DO_SAVE   3
	#define YXML_DOC_DO_FREE   4
	#define YXML_DOC_DO_MASK   0xFFFF
	#define YXML_DOC_OPT_EAT_WS   (0x0001<<16)
	#define YXML_DOC_OPT_FORMATTED_OUTPUT (0x0002<<16)  

	#define YXML_DRV_WALK_PARENT 1
	#define YXML_DRV_WALK_CHILD_FIRST 2
	#define YXML_DRV_WALK_CHILD_LAST  3
	#define YXML_DRV_WALK_SIBLING_NEXT 4
	#define YXML_DRV_WALK_SIBLING_PREV 5

	#define YXML_DRV_INSERT_APPEND_CHILD 1
	#define YXML_DRV_INSERT_AFTER 2
	#define YXML_DRV_INSERT_BEFORE 3
	#define YXML_DRV_INSERT_DELETE 4

	//#define YXML_DRV_NODE_SET_NAME  1
	#define YXML_DRV_NODE_SET_ATTR  2
	#define YXML_DRV_NODE_SET_VALUE 3
	#define YXML_DRV_NODE_GET_NAME  4
	#define YXML_DRV_NODE_GET_ATTR  5
	#define YXML_DRV_NODE_GET_VALUE 6

	#ifdef __cplusplus
	extern "C" {
	#endif 

	#if defined(YXML_USE_DLL) & defined(YXML_DRIVER_USING)

		typedef YXMLEXPORT void (YXMLDRVFUN *_YXML_DRV_ReleaseCString)(YXML_DRV_DomCString *cstr); 
		typedef YXMLEXPORT int  (YXMLDRVFUN *_YXML_DRV_InitializeXercesc)(int true_false,const char *encoding_system,YXML_DRV_DomCString *exception_message);
		/// op_opt = (YXML_DOC_OPT_??|YXML_DOC_OPT_??|...) | YXML_DOC_DO_???;
		typedef YXMLEXPORT int  (YXMLDRVFUN *_YXML_DRV_OpenClose)(YXML_DRV_DocHandle* handle,unsigned op_opt,const char *fname,const char *docname,const char *encoding,YXML_DRV_DomCString *exception_message);
		typedef YXMLEXPORT YXML_DRV_NodeHandle (YXMLDRVFUN *_YXML_DRV_GetRootNode)(YXML_DRV_DocHandle dom_doc,YXML_DRV_DomCString *exception_message);
		/// walk = YXML_DRV_WALK_???
		typedef YXMLEXPORT YXML_DRV_NodeHandle (YXMLDRVFUN *_YXML_DRV_TreeWalk)(YXML_DRV_NodeHandle current,unsigned walk,YXML_DRV_DomCString *exception_message);
		typedef YXMLEXPORT unsigned (YXMLDRVFUN *_YXML_DRV_NodeType)(YXML_DRV_NodeHandle current,YXML_DRV_DomCString *exception_message); ///returns YXML_DRV_NODETYPE_???
		///where=YXML_DRV_INSERT_???  type=YXML_DRV_NODETYPE_???
		typedef YXMLEXPORT YXML_DRV_NodeHandle (YXMLDRVFUN *_YXML_DRV_Insert)(YXML_DRV_NodeHandle current,unsigned where,unsigned type,const char *data,YXML_DRV_DomCString *exception_message);
		///what=YXML_DRV_NODE_???
		typedef YXMLEXPORT YXML_DRV_DomCString (YXMLDRVFUN *_YXML_DRV_NodeGetSet)(YXML_DRV_NodeHandle current,unsigned what,const char *attr_name,const char *data,YXML_DRV_DomCString *exception_message);
	#else
		YXMLEXPORT void YXMLDRVFUN YXML_DRV_ReleaseCString(YXML_DRV_DomCString *cstr); 
		YXMLEXPORT int  YXMLDRVFUN YXML_DRV_InitializeXercesc(int true_false,const char *encoding_system,YXML_DRV_DomCString *exception_message);
		/// op_opt = (YXML_DOC_OPT_??|YXML_DOC_OPT_??|...) | YXML_DOC_DO_???;
		YXMLEXPORT int  YXMLDRVFUN YXML_DRV_OpenClose(YXML_DRV_DocHandle* handle,unsigned op_opt,const char *fname,const char *docname,const char *encoding,YXML_DRV_DomCString *exception_message);
		YXMLEXPORT YXML_DRV_NodeHandle YXMLDRVFUN YXML_DRV_GetRootNode(YXML_DRV_DocHandle dom_doc,YXML_DRV_DomCString *exception_message);
		/// walk = YXML_DRV_WALK_???
		YXMLEXPORT YXML_DRV_NodeHandle YXMLDRVFUN YXML_DRV_TreeWalk(YXML_DRV_NodeHandle current,unsigned walk,YXML_DRV_DomCString *exception_message);
		YXMLEXPORT unsigned YXMLDRVFUN YXML_DRV_NodeType(YXML_DRV_NodeHandle current,YXML_DRV_DomCString *exception_message); ///returns YXML_DRV_NODETYPE_???
		///where=YXML_DRV_INSERT_???  type=YXML_DRV_NODETYPE_???
		YXMLEXPORT YXML_DRV_NodeHandle YXMLDRVFUN YXML_DRV_Insert(YXML_DRV_NodeHandle current,unsigned where,unsigned type,const char *data,YXML_DRV_DomCString *exception_message);
		///what=YXML_DRV_NODE_???
		YXMLEXPORT YXML_DRV_DomCString YXMLDRVFUN YXML_DRV_NodeGetSet(YXML_DRV_NodeHandle current,unsigned what,const char *attr_name,const char *data,YXML_DRV_DomCString *exception_message);
	#endif

	#ifdef __cplusplus
	 }
	#endif 

#endif //defined(YXML_DRIVER) | defined(YXML_DRIVER_USING) 
//////////////////////////////////////////////////////////////////////////////////
#endif //_XML_INTERFACE_IMP_H
