#ifndef _YFILESYS_H
#define _YFILESYS_H

#include <string>
#include <sstream>
#include <list>
#include "ytypes.h"
#include "ytime.h"

/// @brief    .
///   ,   ,    .
namespace YFileSys
{
/** @defgroup FileSysGroup      (   , , , ). 
 *  @ingroup GeneralGroup
 *  @{
 */
	int StrCmpI(const std::string& s1,const std::string& s2);
	std::string getEnv(const char* var_name);
	inline std::string getEnv(std::string var_name) {return YFileSys::getEnv(var_name.c_str());}

	bool isFullName( std::string path);//>Returns true if path contains absolute path
	bool isExists( std::string path);//>Check if file or directory exists
	bool isFileExist(std::string path);//>Check if file exists
	bool isDirExist(std::string path);//>Check if directory exists
	bool isPathExist(std::string path);//>Remove from path filename and check if directory exists
	size_t getFileSize(std::string path);
	YDataTime getTime(std::string path);
	bool rm(std::string path);//>remove file from disk (delete), returns true if file successfuly deleted
	bool CreateDir(std::string path);//>returns false if Already exist, true - if success, exception typeof std::string if not created

	std::string remExt(std::string path);
	std::string getExt(std::string path);
	std::string getDir(std::string path);//>    Windows
	std::string getName(std::string path);//> ,  .
	inline std::string getNameWithoutExt(std::string path){return YFileSys::remExt(getName(path));}
	/**  ,   path ,     getExt()   
	  * ext   ,     ext . ext  
	  *    -    
	  */
	std::string changeExt(std::string path,std::string ext);
	/**   path      changeExt,    :
	  *  extToChange   ,  L1a.pds .    :
	  *   extToChange   (.pds)    path,   ,  
	  *   path,    extToChange    .. .   
	  * path        extToChange ,  path  ext
	  *   
	  */
	std::string changeExtIf(std::string path,std::string extToChange,std::string ext);
	std::string cwd();
	void cwd(std::string path);
	#ifdef WIN32
		///Windows specific
		std::list<std::string> FilesInDir(const char* dir,const char* mask);
		std::string getDriveLetter(std::string path);
		std::string remDrive(std::string path);
		inline std::string getDirWithoutDrive(std::string path) {return YFileSys::getDir(remDrive(path));}
		///Cygwin cpecific
		std::string GetCygwinRoot();
		std::string GetCygwinBin();
		std::string WinPathToPosix(std::string path,bool is_list=false);
		std::string PosixPathToWin(std::string path,bool is_list=false);
	#endif
/** @} */ // end of FileSysGroup  
};
#endif //_YFILESYS_H
