#include <stdlib.h>//malloc(),free(),realloc()
#include <string> 
//#include <stdio.h> //vsprintf
//#include <stdarg.h>//va_list, va_end
#pragma hdrstop
#include "ImageMem.h"

#ifdef __BORLANDC__
	#define SIZEOF_TEST_DYNAMIC 0
#else //Microsoft visual C++
	#define SIZEOF_TEST_DYNAMIC 1
#endif

#if SIZEOF_TEST_DYNAMIC==0
  #if ( sizeof(short)!=2 )
  	#error "Invalid type size, this file assume sizeof(short)==2";
  #endif
#endif
//-----------------------------------------------------------------------------------------------------

static void * ImgDataAlloc(void *ptr,long size_old,long size_new)
{
	if(size_new==0)
  {
  	if(ptr) ::free(ptr);
    return NULL;
  }
	if(ptr)
  {
  	if(size_old<size_new)
    {
    	::free(ptr);
	  	return ::malloc(size_new);
    }
    else if(size_old>size_new)
    {
    	return ::realloc(ptr,size_new);
    }
    else
    	return ptr;
  }
  else
  {
  	return ::malloc(size_new);
  }
}
//-----------------------------------------------------------------------------------------------------
//static
bool AImage::CopyPalette(AImage* to,const AImage* from)
{ //if cant copy - returns false
	const AImageMem8* from8;
	AImageMem8* to8;

	if(		(0!=(from8 = dynamic_cast<const AImageMem8*>(from)))
		 && (0!=(to8 = dynamic_cast<AImageMem8*>(to) ))
		 && (to8->ImageClass() == AImage::IMGC_PALETTE) )
	{
		AImage::Rgb* pal_to = to8->Palette();
		if(	from8->ImageClass() == AImage::IMGC_PALETTE )
		{
			AImage::Rgb* pal_from = from8->Palette();
			const int npal = MIN(to8->GetPaletteEntries(),from8->GetPaletteEntries());
			for( int i = 0; i < npal; i++)
			{
				*pal_to++ = *pal_from++;
			}
			return true;
		}
		else if(	from8->ImageClass() == AImage::IMGC_GRAYSCALE )
		{
			AImage::Rgb pal_from;
			const int npal = MIN(to8->GetPaletteEntries(),from8->GetPaletteEntries());
			const int np1=npal-1;
			for( int i = 0; i < npal; i++)
			{
				pal_from.r=pal_from.g=pal_from.b=Byte((255*i+(np1>>1))/np1);
				*pal_to++ = pal_from;
			}
			return true;
		}
	}
	return false;
}
//-----------------------------------------------------------------------------------------------------
struct __PossibleImageClass_StoreRelations
{
	AImage::YImageClass iclass;
	bool need_chk_bpp;
	int bpp_min;
	int bpp_max;
	AImage::YImageStore istore;
} __iclass2store_table[]={
	{AImage::IMGC_GRAYSCALE, true , 1, 8, AImage::IMGS_AImageMem8 },
	{AImage::IMGC_GRAYSCALE, true , 9,16, AImage::IMGS_AImageMem16},
	{AImage::IMGC_PALETTE  , true , 1, 8, AImage::IMGS_AImageMem8},
	{AImage::IMGC_FLOAT    , false, 0, 0, AImage::IMGS_AImageMemFloat},
	{AImage::IMGC_RGB      , true , 1, 8, AImage::IMGS_AImageMemRgb8 },
	{AImage::IMGC_RGB      , true , 9,16, AImage::IMGS_AImageMemRgb16}
};

bool AImageIsCompatible(AImage *img,AImage::YImageClass iclass,short /*width*/,short /*height*/,short bitsPerPix)
{
	if(!img)
		return false;
	if(img->ImageClass()!=iclass)
		return false;

	int n=sizeof(__iclass2store_table)/sizeof(__iclass2store_table[0]);
	for(int i=0; i<n; i++)
	{
		if(iclass==__iclass2store_table[i].iclass)
		{
			if(img->GetImageStore()==__iclass2store_table[i].istore)
			{
				if(__iclass2store_table[i].need_chk_bpp)
					if(__iclass2store_table[i].bpp_min<=bitsPerPix
					 &&__iclass2store_table[i].bpp_max>=bitsPerPix)
					 return true;
			}
		}
	}
	return false;
/*
	bool ret=true;
	switch(iclass)
	{
//	case AImage::IMGC_BILEVEL:
//		break;
	case AImage::IMGC_GRAYSCALE:
		{
			if(8<bitsPerPix && bitsPerPix<=16)
			{
				if(!dynamic_cast<AImageMem16 *>(img))
				{
					ret=false;
				}
			}
			else if(0<bitsPerPix && bitsPerPix<=8)
			{
				if(!dynamic_cast<AImageMem8 *>(img))
				{
					ret=false;
				}
			}
		}
		break;
	case AImage::IMGC_PALETTE:
		{
			if(0<bitsPerPix && bitsPerPix<=8
				&& AImage::IMGS_AImageMem8 == img->GetImageStore())
			{
//				if(!dynamic_cast<AImageMem8 *>(img))
//				{
//					ret=false;
//				}
			}
			else
				ret=false;
		}
		break;
	case AImage::IMGC_RGB:
		{
			if(0<bitsPerPix && bitsPerPix<=16
				&& AImage::IMGS_AImageMem8 == img->GetImageStore() )
			{
//				if(!dynamic_cast<AImageMemRgb8 *>(img))
//				{
//					ret=false;
//				}
			}
			else
				ret=false;
		}
		break;
	case AImage::IMGC_FLOAT:
		{
			if(!dynamic_cast<AImageMemFloat *>(img))
				ret=false;
		}
		break;
//	case AImage::IMGC_UNKNOWN:
	default:
		{
			ret=false;
		}
	};
	return ret;
*/
}
//-----------------------------------------------------------------------------------------------------
AImage *AImageCreate(AImage *img,AImage::YImageClass iclass,short width,short height,short bitsPerPix)
{
	if(img)
	{
		if(!AImageIsCompatible(img,iclass,width,height,bitsPerPix))
		{
			delete img;
			img=0;
		}
	}
	switch(iclass)
	{
	case AImage::IMGC_BILEVEL:
		{
			img=0;
		}
		break;
	case AImage::IMGC_GRAYSCALE:
		{
			if(8<bitsPerPix && bitsPerPix<=16)
			{
				if(!img) img=new ImageMem16;
				if(img)  img->Create(width,height,bitsPerPix,false);
			}
			else if(0<bitsPerPix && bitsPerPix<=8)
			{
				if(!img) img=new ImageMem8;
				if(img)  img->Create(width,height,bitsPerPix,false);
			}
		}
		break;
	case AImage::IMGC_PALETTE:
		{
			if(0<bitsPerPix && bitsPerPix<=8)
			{
				if(!img) img=new ImageMem8;
				if(img)  img->Create(width,height,bitsPerPix,true);
			}
		}
		break;
	case AImage::IMGC_RGB:
		{
			if(0<bitsPerPix && bitsPerPix<=16)
			{
				if(!img) img=new ImageMemRgb8;
				if(img)  img->Create(width,height,bitsPerPix,true);
			}
		}
		break;
	case AImage::IMGC_FLOAT:
		{
			if(!img) img=new ImageMemFloat;
			if(img)  img->Create(width,height,bitsPerPix,false);
		}
		break;
//	case AImage::IMGC_UNKNOWN:
	default:
		{
			img=0;
		}
	};
	return img;
}
/////////////////////////////////////////////////////////////////////////////////
/////////////// classes AImageMem***  ///////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
//static
void AImageMem8::SetTo(AImageMem8* img,Pixel8 color)
{
	if(img==0)
		throw "AImageMem8::SetTo() : img==0";
	if(!img->IsOk())
		throw "AImageMem8::SetTo() : img is NOT OK";
	const int h = img->Height();
	const int w = img->Width();
	const int sh= img->NextLineShift()-w;
	Pixel8* pix = (*img)[0];
	for(int y = 0; y < h; y++)
	{
		int x=w;
		while(x--)
			*pix++ = color;
		pix+=sh;
	}
}
//static
void AImageMem16::SetTo(AImageMem16* img,Pixel16 color)
{
	if(img==0)
		throw "AImageMem16::SetTo() : img==0";
	if(!img->IsOk())
		throw "AImageMem16::SetTo() : img is NOT OK";
	const int h = img->Height();
	const int w = img->Width();
	const int sh= img->NextLineShift()-w;
	Pixel16* pix = (*img)[0];
	for(int y = 0; y < h; y++)
	{
		int x=w;
		while(x--)
			*pix++ = color;
		pix+=sh;
	}
}
//static
void AImageMemRgb8::SetTo(AImageMemRgb8* img,Rgb color)
{
	if(img==0)
		throw "AImageMemRgb8::SetTo() : img==0";
	if(!img->IsOk())
		throw "AImageMemRgb8::SetTo() : img is NOT OK";
	AImageMem8::SetTo(img->GetPlane8(0),color.r);
	AImageMem8::SetTo(img->GetPlane8(1),color.g);
	AImageMem8::SetTo(img->GetPlane8(2),color.b);
}
/////////////////////////////////////////////////////////////////////////////////
/////////////// class ImageMem16 ////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
//static
const char *ImageMem16::ThisClassName()
{
	return "ImageMem16";
}

void ImageMem16::nullify()
{
	wid=0;  len=0;  bits=0;
  data=NULL;
}

//virtual
void ImageMem16::Clear()
{
	data=(Pixel16 *)ImgDataAlloc(data,0,0); //free
  nullify();
}

bool ImageMem16::Create(short width,short length,short bitsPerPix,bool /*hasPalette*/)
{
long size_old=long(wid)*long(len);
long size_new=long(width)*long(length);

	data=(Pixel16 *)ImgDataAlloc(data,size_old*sizeof(*data),size_new*sizeof(*data));
  if(data==NULL)
  {
  	Clear();
    //throw "Insuff memory";
		return false;
  }
  else
	{
  	wid=width;
    len=length;
    bits=bitsPerPix;
  }
	return true;
}

//virtual
AImage::YImageClass  ImageMem16::ImageClass()
const
{
	//return AImage::IMGC_BILEVEL;
	return AImage::IMGC_GRAYSCALE;
	//return AImage::IMGC_PALETTE;
	//return AImage::IMGC_RGB;
}
//virtual
void ImageMem16::read(int x,int y,Pixel16 *data,int len)
const
{
	::memcpy(data,(*this)[y]+x,len*sizeof(Pixel16));
}

/////////////////////////////////////////////////////////////////////////////////
/////////////// class ImageMem16Stuff ///////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
ImageMem16Stuff::Error::Error(const char *fname,int nline,const ImageMem16Stuff *obj,bool del_msg,ErrorStatus id_err,const char *msgfmt,...)
:ErrorStatusBase(fname,nline,ImageMem16Stuff::ThisClassName(),obj?obj->ClassName():"(null)",del_msg)
{
  err=id_err;
	if(msg_need_delete)
	{
		msg=new char[512];

//		va_list argptr;
//		va_start(argptr, msgfmt);
//		::vsprintf(msg,msgfmt,argptr);
//		va_end(argptr);
	}
	else
		msg=(char *)msgfmt;
}
/*
#define ERROR_CantLoad(obj) throw ImageMem16Stuff::Error(__FILE__,__LINE__,obj,false,\
        ImageMem16Stuff::Error::errCantLoadObject, \
        "Can't Load() into ImageMem16Stuff object")
#define ERROR_CantCreate(obj) throw ImageMem16Stuff::Error(__FILE__,__LINE__,obj,false,\
        ImageMem16Stuff::Error::errCantCreateObject, \
        "Can't Create() ImageMem16Stuff object")
#define ERROR_CantClear(obj) throw ImageMem16Stuff::Error(__FILE__,__LINE__,obj,false,\
        ImageMem16Stuff::Error::errCantClearObject, \
        "Can't Clear() ImageMem16Stuff object")
*/

//static
const char *ImageMem16Stuff::ThisClassName()
{
	return "ImageMem16Stuff";
}
//virtual
void ImageMem16Stuff::Load(const char * /*ozfilename*/,ProgressCounter* /*indicator*/)
{
	throw std::string("Never can't Load() ImageMem16Stuff object.");
}
//virtual
bool ImageMem16Stuff::Create(short /*width*/,short /*height*/,short /*bitsPerPix*/,bool /*hasPalette*/)
{
	throw "Never can't Create() ImageMem16Stuff object.";
	return false; //unreacheble, but required by Microsoft VC++
}
//virtual
void ImageMem16Stuff::Clear()
{
	throw "Never can't Clear() ImageMem16Stuff object.";
}

/////////////////////////////////////////////////////////////////////////////////
/////////////// class ImageMem8 /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
//static
const char *ImageMem8::ThisClassName()
{
	return "ImageMem8";
}
void ImageMem8::nullify()
{
	wid=0;
  len=0;
	bits=8;
  next_line_shift=0;
  data=0;
	pal=0;
	pal_entries=0;
	img_class=IMGC_UNKNOWN;
}

ImageMem8::ImageMem8()
{
	nullify();
}
//virtual
ImageMem8::~ImageMem8()
{
	Create(0,0);
}
//virtual
void ImageMem8::Clear()
{
	data=(Pixel8 *)ImgDataAlloc(data,0,0); //free
	pal=(AImage::Rgb *)ImgDataAlloc(pal,0,0); //free
  nullify();
}

//virtual
bool ImageMem8::Create(short width,short height,short bitsPerPix,bool hasPalette)
{
long size_old=long(wid)*long(len);
long size_new=long(width)*long(height);

	data=(Pixel8 *)ImgDataAlloc(data,size_old*sizeof(*data),size_new*sizeof(*data));
  if(data==NULL)
  {
  	Clear();
    //throw "Insuff memory";
		return false;
  }
  else
	{
  	wid=width;
    len=height;
    bits=bitsPerPix;
    next_line_shift=width; //Not Always!!! /Another file format, correct for all sizeof(Pixel8) value/
		img_class=hasPalette?AImage::IMGC_PALETTE:AImage::IMGC_GRAYSCALE;
		if(img_class==AImage::IMGC_PALETTE )
		{
			pal=(AImage::Rgb *)ImgDataAlloc(pal,sizeof(AImage::Rgb)*pal_entries,sizeof(AImage::Rgb)*256);
			if(pal)
				pal_entries=256;
		}
		else
		{
			if(pal)
			{
				pal=(AImage::Rgb *)ImgDataAlloc(pal,sizeof(AImage::Rgb)*pal_entries,0); //free
				pal_entries=0;
			}
		}
  }
	return true;
}


//virtual
AImage::YImageClass  ImageMem8::ImageClass()
const
{
	return img_class;
	//return AImage::IMGC_BILEVEL;
	//return AImage::IMGC_GRAYSCALE;
	//return AImage::IMGC_PALETTE;
	//return AImage::IMGC_RGB;
}
void ImageMem8::read(int x,int y,Pixel16 *line,int len)
const
{
	Pixel8 *p=ImageMem8::operator[](y)+x;
#if 1
	while(len--)
	{
		*line++=*p++;
	}
#else
__asm {
	push ecx
	push esi
	push edi
	mov esi,p;
	mov ecx,len;
	mov edi,line;
	xor eax,eax;
lab1:
	lodsb;
	stosw;
	dec ecx;
	jnz lab1;
	pop edi
	pop esi
	pop ecx
};
#endif
/*
	Pixel8 *p=data+y*next_line_shift+x;
	while(len--)
	{
		*line++=*p++;
	}
*/
}
/////////////////////////////////////////////////////////////////////////////////
///////////////class ImageMemFloat///////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
//static
const char *ImageMemFloat::ThisClassName()
{
	return "ImageMemFloat";
}
void ImageMemFloat::nullify()
{
	wid=0;
	len=0;
	bits=8*sizeof(*data);
	data=0;
}

ImageMemFloat::ImageMemFloat()
{
	nullify();
}
//virtual
ImageMemFloat::~ImageMemFloat()
{
	Create(0,0);
}
//virtual
void ImageMemFloat::Clear()
{
	data=(PixelFloat *)ImgDataAlloc(data,0,0); //free
	nullify();
}

//virtual
bool ImageMemFloat::Create(short width,short height,short /*bitsPerPix*/,bool /*hasPalette*/)
{
long size_old=long(wid)*long(len);
long size_new=long(width)*long(height);

	data=(PixelFloat *)ImgDataAlloc(data,size_old*sizeof(PixelFloat),size_new*sizeof(PixelFloat));
  if(data==NULL)
  {
	nullify();
	return false;
  }
  else
  {
  	wid=width;
    len=height;
    bits=8*sizeof(PixelFloat);//bitsPerPix;
    //next_line_shift=width; //Always for Float to compatibility with FFT algorithm!!!
  }
	return true;
}


//virtual
void ImageMemFloat::SetTo(PixelFloat color)
{
		const int h = Height();
		const int w = Width();
		PixelFloat* pix = (*this)[0];
		for(int y = 0; y < h; y++)
		{
			int x=w;
			while(x--)
				*pix++ = color;
		}
}
#ifdef __BORLANDC__
	#pragma argsused
#endif
void ImageMemFloat::read(int x,int y,Pixel16 *data,int len)
const
{
	throw "ImageMemFloat::read() - unsupported";
/*
	PixelFloat *p=(*this)[y]+x;
	while(len--)
	{
		*data++=Pixel16(*p++);
	}
*/
}
/////////////////////////////////////////////////////////////////////////////////
///////////////class ImageMemRgb8  ///////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
//static
const char * ImageMemRgb8::ThisClassName()
{
	return "ImageMemRgb8";
}
//virtual
AImage::YImageClass  ImageMemRgb8::ImageClass()
const
{
	return AImage::IMGC_RGB;
}

void ImageMemRgb8::nullify()
{
	wid=0;
  len=0;
  bits=0;
	for(int i=0; i<3; i++)
	{
		data8[i]=0;
	}
}
//virtual
bool ImageMemRgb8::IsOk()
const
{
	for(int i=0; i<3; i++)
	{
		if(data8[i]==0)
			return false;
		else if(!(data8[i]->IsOk()))
			return false;
	}
	return true;
}
//virtual
bool ImageMemRgb8::Create(short width,short height,short bitsPerPix,bool )
{
	if(bitsPerPix>8 ||bitsPerPix<1 )
		throw "ImageMemRgb8::Create() more than 86 bits per pixel per plane not supported";
	try
	{
		for(int i=0; i<3; i++)
		{
			if(!data8[i])
				data8[i]=new ImageMem8;
			if(!data8[i] )
				throw "ImageMemRgb8::Create() : insufficient memory";
			data8[i]->Create(width,height,bitsPerPix,false);
		}
		wid=width;
		len=height;
		bits=bitsPerPix;
	}
	catch(...)
	{
		Clear();
		return false;
	};
	return true;
}
//virtual
void ImageMemRgb8::Clear()
{
	for(int i=0; i<3; i++)
	{
		if(data8[i])
		{
			delete data8[i];
			data8[i]=0;
		}
	}
	nullify();
}
//virtual
AImageMem8  * ImageMemRgb8::GetPlane8(int plane)
const
{
	if(this->IsOk())
			return data8[plane];
	return 0;
}

#ifdef __BORLANDC__
	#pragma argsused
#endif
void ImageMemRgb8::read(int x,int y,Pixel16 *data,int len)
const
{
	throw "ImageMemRgb8::read() - unsupported";
/*
	PixelFloat *p=GetPlane8(1)[y]+x;
	while(len--)
	{
		*data++=Pixel16(*p++);
	}
*/
}

/////////////////////////////////////////////////////////////////////////////////
///////////////classes ImageFragment*** /////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////
//////////// class AImage ///////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////
//static  
const char * AImage::ImageStoreName(YImageStore istore)
{
	switch(istore)
	{
//	case IMGS_Unknown:
//		return "IMGS_Unknown";
	case IMGS_AImageMem8:
		return "IMGS_AImageMem8";
	case IMGS_AImageMem16:
		return "IMGS_AImageMem16";
	case IMGS_AImageMemFloat:
		return "IMGS_AImageMemFloat";
	case IMGS_AImageMemRgb8:
		return "IMGS_AImageMemRgb8";
	case IMGS_AImageMemRgb16:
		return "IMGS_AImageMemRgb16";
	};
	return "IMGS_Unknown";
}
//object identification
//static
const char * AImage::ImageClassName(YImageClass iclass)
{
	switch(iclass)
	{
	case IMGC_BILEVEL:
		return "BILEVEL";
	case IMGC_GRAYSCALE:
		return "GRAYSCALE";
	case IMGC_PALETTE:
		return "PALETTE";
	case IMGC_RGB:
		return "RGB";
	case IMGC_FLOAT:
		return "FLOAT";
//	case IMGC_UNKNOWN:
	default:
		return "UNKNOWN";
	};
}
//static
const char *AImage::ThisClassName()
{
	return "AImage";
}
//static
const char *AImageMem8::ThisClassName()
{
	return "AImageMem8";
}
//static
const char *AImageMem16::ThisClassName()
{
	return "AImageMem16";
}
//static
const char *AImageMemRgb8::ThisClassName()
{
	return "AImageMemRgb8";
}
//static
const char *AImageMemRgb16::ThisClassName()
{
	return "AImageMemRgb16";
}
//static
const char *AImageMemFloat::ThisClassName()
{
	return "AImageMemFloat";
}
//static
const char *ImageFragment8::ThisClassName()
{
	return "ImageFragment8";
}
//static
const char *ImageFragment16::ThisClassName()
{
	return "ImageFragment16";
}
//static
const char *ImageFragmentRgb8::ThisClassName()
{
	return "ImageFragmentRgb8";
}
