#include "ImgTools.h"

MImages2Gray::MImages2Gray(AImage** src, int Number)
{
	Layers = new AImage* [3*Number];
	n_out = 0;

	if (!src)
		throw "Wrong Array of Images in MImages2Gray::MImages2Gray().";
	int height = 0;
	int width = 0;
	for (int k = 0; k < Number; k++)
	{
		if (!src[k])
			throw "Wrong Image in Array of inputed images in MImages2Gray::MImages2Gray().";
		if (k==0){
			height = src[k]->Height();
			width  = src[k]->Width();
		}
		else{
			if ( (height != src[k]->Height()) || (width != src[k]->Width()))
				throw "Different Sizes Images in MImages2Gray::MImages2Gray()";
		}

		switch(src[k]->GetImageStore())
		{
		case AImage::IMGS_AImageMem16:
			{
				const AImageMem16 *im=dynamic_cast<const AImageMem16 *>(src[k]);
				if(!im)
					throw "MImages2Gray : SHARED LIBRARY ERROR: object with store type IMGS_AImageMem16 can't dynamic_cast to AImageMem16*";
				if(im->ImageClass()!=AImage::IMGC_GRAYSCALE)
					throw "MImages2Gray can process only GRAYSCALE images when container type is AImageMem16";

				Layers[n_out++] = src[k];
			}
			break;
		case AImage::IMGS_AImageMem8:
			{
				const AImageMem8 *im=dynamic_cast<const AImageMem8 *>(src[k]);
				if(!im)
					throw "MImages2Gray : SHARED LIBRARY ERROR: object with store type IMGS_AImageMem8 can't dynamic_cast to AImageMem8*";
				if(im->ImageClass()!=AImage::IMGC_GRAYSCALE)
					throw "MImages2Gray can process only GRAYSCALE images when container type is AImageMem16";

				Layers[n_out++] = src[k];
			}
			break;
		case AImage::IMGS_AImageMemRgb8:
			{
				const AImageMemRgb8 *rgb8=dynamic_cast<const AImageMemRgb8 *>(src[k]);
				if(!rgb8)
					throw "MImages2Gray : SHARED LIBRARY ERROR: object with store type IMGS_AImageMemRgb8 can't dynamic_cast to AImageMemRgb8*";

				int n_plan = src[k]->NumPlanes();
				for (int n = 0; n < n_plan; n++)
				{
					AImageMem8* plane = rgb8->GetPlane8(n);
					Layers[n_out++] = plane;
				}
			}
			break;
		}
	}

}

MImages2Gray::~MImages2Gray()
{
	if (Layers)
		delete[] Layers;
}






