#include <stdio.h>//sprintf()
#include <stdlib.h>
//#include <mem.h>
#include <memory.h>
#pragma hdrstop
#include "Oz.h"
//#include "ImgDrive.h"

#ifdef __BORLANDC__
	#define SIZEOF_TEST_DYNAMIC 0
#else //Microsoft visual C++
	#define SIZEOF_TEST_DYNAMIC 1
#endif

#if SIZEOF_TEST_DYNAMIC==0
  #if ( sizeof(short)!=2 )
  	#error "Invalid type size, this file assume sizeof(short)==2";
  #endif
#endif

using namespace IFF;

OzFile::OzFile()
: YFile()
{
	::memset(&head,0,sizeof(head));
#if SIZEOF_TEST_DYNAMIC==1
  if( sizeof(OzWord)!=2 )
  	throw "Invalid type size, sizeof(OzWord) MUST equal 2";
#endif
}
//virtual 
OzFile::~OzFile()
{
	close();
}

void OzFile::open(const char * szFileName,OpenMode access,
			int  Width,int  Height,int  bitsPerPixel)
{
	close();
	if(access==YFile::UIO_CREATE || access==YFile::UIO_CREATE_OVERWRITE)
	{
		if(Width<=0 || Height<=0 )
			throw "Invalid image size parameter";
		if(bitsPerPixel<=0 || bitsPerPixel>16)
			throw "Invalid image depth parameter";
	}
	YFile::_open(szFileName,access);
	if(!YFile::IsOk())
		throw "file open error";

	switch(this->GetMode())
	{
	case UIO_CREATE:
	case UIO_CREATE_OVERWRITE:
			::memset(&head,0,sizeof(head));
			head.Width=OzWord(Width);
			head.Length=OzWord(Height);
			head.Bits=OzWord(bitsPerPixel);
			writeHeader();
			break;
	case UIO_RDONLY:
	case UIO_MODIFY:
			readHeader();
			break;
	default:
		throw "unknown file open mode";
	};
}
void OzFile::close()
{
	memset(&head,0,sizeof(head));
	YFile::_close();
}

void OzFile::readHeader()
{
	const int len=sizeof(head);
	if(len!=_read(0,&head,len))
		throw "can't read OZ-header, probably file corrupted";
	if(head.Bits<=0 || head.Bits>16 )
		head.Bits=10;
}
void OzFile::writeHeader()
{
	const int len=sizeof(head);
	if(len!=_write(0,&head,len))
		throw "can't write OZ-header, probably disk full";
}

void OzFile::read(int x,int y,OzWord *line,int len)
{
	int ll=len*sizeof(OzWord);
	if(ll!=_read(sizeof(head)+sizeof(OzWord)*(head.Width*y+x),line,ll))
		throw "can't read data, probably file corrupted";
}
void OzFile::write(int x,int y,const OzWord *line,int len)
{
	int ll=len*sizeof(OzWord);
	if(ll!=_write(sizeof(head)+sizeof(OzWord)*(head.Width*y+x),line,ll))
		throw "can't write data, probably disk full";
}

OzWord OzFile::GetChanel() 
const
{ 
	return head.Chan; 
}
void   OzFile::SetChanel(OzWord channel) 
{ 
	head.Chan = channel; 
}
OzWord OzFile::GetTrajectory() 
const
{ 
	return head.Trajectory; 
}
void   OzFile::SetTrajectory(OzWord traject) 
{ 
	head.Trajectory = traject; 
}
void   OzFile::GetTime(OzWord& hour,OzWord& minutes,OzWord& seconds,OzWord& millisec) 
const
{
	hour=head.begHour;
	minutes=OzWord(head.begMinutes);
	seconds=OzWord(head.begSecond1000/1000);
	millisec=OzWord(head.begSecond1000%1000);
}
void   OzFile::GetTimeEnd(OzWord& hour,OzWord& minutes,OzWord& seconds,OzWord& millisec) 
const
{
	hour=head.endHour;
	minutes=OzWord(head.endMinutes);
	seconds=OzWord(head.endSecond1000/1000);
	millisec=OzWord(head.endSecond1000%1000);
}
void   OzFile::SetTime(OzWord hour,OzWord minutes,OzWord seconds,OzWord millisec)
{
	head.begHour=OzWord(hour);
	head.begMinutes=OzWord(minutes);
	head.begSecond1000=OzWord(seconds*1000+millisec);
}
void   OzFile::SetTimeEnd(OzWord hour,OzWord minutes,OzWord seconds,OzWord millisec)
{
	head.endHour=OzWord(hour);
	head.endMinutes=OzWord(minutes);
	head.endSecond1000=OzWord(seconds*1000+millisec);
}
void   OzFile::GetDate(OzWord& year,OzWord& month,OzWord& day)
const
{
	year=head.year;
	month=head.month;
	day=head.day;
}
void   OzFile::SetDate(OzWord year,OzWord month,OzWord day)
{
	head.year=year;
	head.month=month;
	head.day=day;
}
void   OzFile::GetHeader(Header* header)
const
{
	::memcpy(header,&head,sizeof(head));
}
void   OzFile::SetHeader(Header* header) 
{ 
	::memcpy(&head,header,sizeof(head)); 
	if(head.Bits==0)
		head.Bits=10;
}
bool   OzFile::IsOneSeance(const OzFile& f) 
const
{
	if(  head.Trajectory	== f.head.Trajectory
		&& head.day           == f.head.day
		&& head.month         == f.head.month
		&& head.year          == f.head.year
		&& head.begHour       == f.head.begHour
		&& head.begMinutes    == f.head.begMinutes
		&& head.begSecond1000 == f.head.begSecond1000
		&& head.endHour       == f.head.endHour
		&& head.endMinutes    == f.head.endMinutes
		&& head.endSecond1000 == f.head.endSecond1000
		&& head.Width         == f.head.Width
		&& head.Length        == f.head.Length
		)
		return true;
	else
		return false;
}


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////   D R I V E R//////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
/*
#include <io.h>
#include <fcntl.h>
//#include <sys\stat.h>
#pragma hdrstop

ImgInfo * OZ_OpenImageFile(const char *fname)
{
	ImgInfo * imInf=new ImgInfo;
	if(imInf)
	{
		::memset(imInf,0,sizeof(ImgInfo));
		imInf->IsOk=1;
		imInf->struct_size=sizeof(ImgInfo);
		//::strcpy(imInf->format,"OZ");
		imInf->ErrMsg[0]=0;

 		//char msg_buf[512];// for using by indicator
		int handler = ::open(fname,O_RDONLY|O_BINARY);
		imInf->img_file_obj=(void *)handler;
		if(handler == -1 )
		{
			//if(indicator)
			//{
			//	::sprintf(msg_buf,"%s %s",indicator->russian()?"   ":"Can't open file",fname);
    	//	indicator->error(msg_buf);
			//}
			throw "No such file";
		}
	}
	return imInf;
}

int OZ_GetImageInfo(ImgInfo * imInf,int image_id)
{
	if(imInf)
	{
		int handler = (int)(imInf->img_file_obj);
		if(handler != -1 )
		{
			short width,length;
			::lseek(handler,10*sizeof(width),SEEK_SET);
			::read(handler,&width,sizeof(width));
			::read(handler,&length,sizeof(length));
			imInf->img_class=AImage::IMGC_GRAYSCALE; //numerically equal enum AImage::YImageClass
			imInf->num_images=1;//number of different images in file
			imInf->image_id=0;  //Get info on this image (0<=image_id<num_images)
			imInf->bits=10;
			imInf->width=width;
			imInf->height=length;
			imInf->next_line_shift=width;
		}
	}
	return 0;
}
int OZ_LoadImage(ImgInfo * imInf,void *topleft,int next_line_shift,ProgressCounter* indicator)
{
	if(imInf)
	{
		int handler = (int)(imInf->img_file_obj);
		if(handler != -1 )
		{
			::lseek(handler,16*sizeof(short),SEEK_SET);
			int length=imInf->height;
			int width=imInf->width;
			int next_line=imInf->next_line_shift;
			if(indicator)
			{
		 		char msg_buf[512];// for using by indicator
				char *fname="FileName";
				::sprintf(msg_buf,"%s %s",indicator->russian()?" ":"Loading file",fname);
				indicator->start(msg_buf,0,length-1);
			}
			bool need_abort=false;
			short *data=(short *)topleft;
			for(int i=0;i<length; i++)
			{
  			if(indicator) need_abort=indicator->current(i);
				if(need_abort) break;
				::read(handler,data+i*next_line,long(width)*sizeof(*data));
			}
			if(indicator)
			{
  			if(!need_abort)
		 			 indicator->finish();
			}
		}
	}
	return 0;
}

int OZ_CloseImageFile(ImgInfo ** imInf)
{//** because nullify pointer to ImgInfo
	if(imInf && *imInf)
	{
		int handler = (int)((*imInf)->img_file_obj);
		if(handler != -1 )
		{
			::close(handler);
			(*imInf)->img_file_obj=(void *)(-1);
		}
		delete (*imInf); 
		(*imInf)=0;
	}
	return 0;
}
*/