#ifndef _ZOOMFACT_H
#define _ZOOMFACT_H
////////////////////////////////////////////////////
#include <windows.h>
////////////////////////////////////////////////////
// function
// ZoomValue() - calculate zoomed value with rounding (upper bound).
// ZoomValueNR() - WITHOUT rounding, (low bound).
class ZoomFactor
{
	int zoom;
public:
	ZoomFactor(int _zoom=1) {*this=_zoom;}
  ~ZoomFactor() {}
  int ZoomValue(int value,bool reverse=false) const { return _ZoomValue(value,(reverse)?(-zoom):zoom);}
  int ZoomValueNR(int value,bool reverse=false) const { return _ZoomValueNR(value,(reverse)?(-zoom):zoom);}
	ZoomFactor& operator=(int _zoom) { if(_zoom==0 || _zoom==-1) zoom=1; else zoom=_zoom; return *this;}
  ZoomFactor& operator+=(int dx) {int z=zoom+dx; if(zoom<-1&& z>=-1)zoom=z+2;else if(zoom>=1 && z< 1) zoom=z-2; else zoom=z; return *this;}
  ZoomFactor& operator-=(int dx) {return this->operator+=(-dx);}
  operator int() const { return zoom;}
private:
  static int _ZoomValue(int value,int zm)  { if(zm>0) return value*zm; else return (value-zm-1)/(-zm);}
  static int _ZoomValueNR(int value,int zm){ if(zm>0) return value*zm; else return (value)/(-zm);}
};
class ZoomFactor2D
{
public:
	ZoomFactor X,Y;
  ZoomFactor2D(int zoom_x=1,int zoom_y=1) {X=zoom_x; Y=zoom_y;}
  ZoomFactor2D(const SIZE& zoom) {X=zoom.cx; Y=zoom.cy;}
  SIZE ZoomValue(const SIZE& val,bool reverse=false)   const 
					{ SIZE sz; sz.cx=X.ZoomValue(val.cx,reverse); sz.cy=Y.ZoomValue(val.cy,reverse); return sz;}
  POINT ZoomValue(const POINT& val,bool reverse=false)   const 
					{ POINT pt; pt.x=X.ZoomValue(val.x,reverse); pt.y=Y.ZoomValue(val.y,reverse); return pt;}
  SIZE ZoomValueNR(const SIZE& val,bool reverse=false) const 
					{ SIZE sz; sz.cx=X.ZoomValueNR(val.cx,reverse);sz.cy=Y.ZoomValueNR(val.cy,reverse); return sz;}
	bool operator==(const ZoomFactor2D & z2) const { return (X==z2.X && Y==z2.Y);}
	bool operator!=(const ZoomFactor2D & z2) const { return !(*this==z2);}
	bool operator==(int z2) const { return (X==z2 && Y==z2);}
	bool operator!=(int z2) const { return (X!=z2 || Y!=z2);}
	ZoomFactor2D& operator=(int _zoom) { X=Y=_zoom; return *this;}
	ZoomFactor2D& operator=(const ZoomFactor2D& _zoom) { X=_zoom.X; Y=_zoom.Y; return *this;}
};
////////////////////////////////////////////////////
#endif //_ZOOMFACT_H

