#ifndef _MSILIEQLZ_H
#define _MSILIEQLZ_H
////////////////////////////////////////////////////////////////////////////////////////
#include "aimage.h"
#include "progrcnt.h"
////////////////////////////////////////////////////////////////////////////////////////
// MSliEqlz.h - SlidingEqualization filter class header file                          // 
// by Mintchenkov M.V.                                                                //
////////////////////////////////////////////////////////////////////////////////////////
class MSlidingEqualization 
{
	long *hist;
	const AImage* src_image;
	int N_colors;
	int Hi;
	int Wd;
	int Bt;
	AImage::YImageClass ClassType;
private:
	void CloseThis();
public:
	MSlidingEqualization();  
	virtual ~MSlidingEqualization() { CloseThis(); }
	virtual void Init(const AImage *src);
	virtual bool Run(AImage* dst,int Original_XFrmSz,int Original_YFrmSz, ProgressCounter* Ind);	

	virtual void Close() { CloseThis(); }// use it to free up memory in use

	// parameters for Destination Image
	virtual inline int Height() { return Hi; }// use it to get current height of image
	virtual inline int Width() { return Wd; }// use it to get current width of image
	virtual int Bits() { return Bt; }// use it to get current BitsPerPixel of image
	virtual inline AImage::YImageClass ImageClass() { return ClassType; }// use it to get current image class 
};
////////////////////////////////////////////////////////////////////////////////////////
#endif //_MSILIEQLZ_H
